/*
 * Copyright (C) 2004 by X S ( Morioka Yuichi ) .
 *
 * 2004/09/18쐬B
 */
package jp.co.infoseek.hp.streakeagle.lib.shogi;


/**
 * ֘Ã[eBeB[\bhyђ萔񋟂NXB
 * 
 * @author X S ( Morioka Yuichi )
 * @version 1.0 
 * @since 1.0
 */
public class KomaUtil {
  
  /**
   * B
   * 
   * @since 1.0
   */
  public static final int HU = 1;
  

  /**
   * ԁB
   * 
   * @since 1.0
   */
  public static final int KYOU = 2;
  

  /**
   * jnB
   * 
   * @since 1.0
   */
  public static final int KEI = 3;
  

  /**
   * B
   * 
   * @since 1.0
   */
  public static final int GIN = 4;
  

  /**
   * B
   * 
   * @since 1.0
   */
  public static final int KIN = 5;
  

  /**
   * pB
   * 
   * @since 1.0
   */
  public static final int KAKU = 6;
  

  /**
   * ԁB
   * 
   * @since 1.0
   */
  public static final int HISYA = 7;
  

  /**
   * B
   * 
   * @since 1.0
   */
  public static final int OU = 8;


  /**
   * 5bitڂ""E"s"\B
   * 
   * @since 1.0
   */
  public static final int NARI = 16; 


  /**
   * 6bitڂ""E""\B
   * 
   * @since 1.0
   */
  public static final int GOTE = 32; 
  

  /**
   * ŎA̋̋ԂB
   * 
   * @param komaInfo B
   * @return ȂtrueAȂfalseB
   */
  public static boolean isSente( int komaInfo ) {
    
    return ( komaInfo & GOTE ) != GOTE;
    
  }// isSente(int) 



  /**
   * Ŏw肵̌^iǑ^jԂB
   * 
   * @param komaInfo ̋̌^ԂB
   * @return Ŏw肳ꂽ̌^B
   */
  public static int getArchetype( int komaInfo ) {
    
    return komaInfo & 0x0f;
    
  }// getArchetype(int)
  
  
  /**
   * Ŏw肵̌^iEs܂ށjԂB
   * 
   * @param komaInfo ̋̌^ԂB
   * @return Ŏw肳ꂽ̌^B
   */
  public static int getType( int komaInfo ) {
   
    return komaInfo & 0x1f; 
    
  }// getType(int)
  

  /**
   * Ŏw肵ڈړłʒȗ΍W̔zԂB
   * ("ڈړ\Ȉʒu"Ƃ́AE(܂)EEjnEE(΂߂ɓʒû)En(΂߈ӊOɓʒû)
   *  ړ\ȈʒuwBԁEpEԋyїEn̑OLȊÖړ́A"ڈړ"Ƃ͌Ă΂ȂB)
   * Ⴆ΁A<code>HU</code>ȂԂl<code>{{0,-1}}</code>(H̃}X)A
   * <code>KEI | GOTE</code>ȂԂl<code>{{-1,2},{1,2}}</code>(肩猩ēḦE̋)łB
   * 
   * @param komaInfo ̌^B
   * @return ړłʒu̔zB
   *          evf͒2intzŁA0Ԗڂ̗vf؂A1Ԗڂ̗vfi\B
   */
  public static int[][] getDirectMovablePositionArray( int komaInfo ) {
    
    // Eŕ
    if( isSente( komaInfo ) ){
      /* ̏ꍇ */

      switch( getType( komaInfo ) ) {
        
        case HU    : return SENTE_DIRECT_MOVABLE_POSITIONS[ 0 ];
        case KYOU  : return SENTE_DIRECT_MOVABLE_POSITIONS[ 1 ];
        case KEI   : return SENTE_DIRECT_MOVABLE_POSITIONS[ 2 ];
        case GIN   : return SENTE_DIRECT_MOVABLE_POSITIONS[ 3 ];
        case KIN   : return SENTE_DIRECT_MOVABLE_POSITIONS[ 4 ];
        case KAKU  : return SENTE_DIRECT_MOVABLE_POSITIONS[ 5 ];
        case HISYA : return SENTE_DIRECT_MOVABLE_POSITIONS[ 6 ];
        case OU    : return SENTE_DIRECT_MOVABLE_POSITIONS[ 7 ];  
        case HU    | NARI : return SENTE_DIRECT_MOVABLE_POSITIONS[ 4 ];
        case KYOU  | NARI : return SENTE_DIRECT_MOVABLE_POSITIONS[ 4 ];
        case KEI   | NARI : return SENTE_DIRECT_MOVABLE_POSITIONS[ 4 ];
        case GIN   | NARI : return SENTE_DIRECT_MOVABLE_POSITIONS[ 4 ]; 
        case KAKU  | NARI : return SENTE_DIRECT_MOVABLE_POSITIONS[ 8 ]; 
        case HISYA | NARI : return SENTE_DIRECT_MOVABLE_POSITIONS[ 9 ]; 
        
      }// switch(...)

    } else {
      /* ̏ꍇ */
      
      switch( getType( komaInfo ) ) {
        
        case HU    : return GOTE_DIRECT_MOVABLE_POSITIONS[ 0 ];
        case KYOU  : return GOTE_DIRECT_MOVABLE_POSITIONS[ 1 ];
        case KEI   : return GOTE_DIRECT_MOVABLE_POSITIONS[ 2 ];
        case GIN   : return GOTE_DIRECT_MOVABLE_POSITIONS[ 3 ];
        case KIN   : return GOTE_DIRECT_MOVABLE_POSITIONS[ 4 ];
        case KAKU  : return GOTE_DIRECT_MOVABLE_POSITIONS[ 5 ];
        case HISYA : return GOTE_DIRECT_MOVABLE_POSITIONS[ 6 ]; 
        case OU    : return GOTE_DIRECT_MOVABLE_POSITIONS[ 7 ];  
        case HU    | NARI : return GOTE_DIRECT_MOVABLE_POSITIONS[ 4 ];
        case KYOU  | NARI : return GOTE_DIRECT_MOVABLE_POSITIONS[ 4 ];
        case KEI   | NARI : return GOTE_DIRECT_MOVABLE_POSITIONS[ 4 ];
        case GIN   | NARI : return GOTE_DIRECT_MOVABLE_POSITIONS[ 4 ]; 
        case KAKU  | NARI : return GOTE_DIRECT_MOVABLE_POSITIONS[ 8 ]; 
        case HISYA | NARI : return GOTE_DIRECT_MOVABLE_POSITIONS[ 9 ];
        
      }// switch(...)
      
    }// if(isSente(komaInfo))

    if( true ) assert false : "䂪ڂ̖͂[gʉ߂܂B";    
    return null;
    
  }// getDirectMovablePositionList(int)


  /**
   * ̋ڈړ\ȑΈʒuzB
   */
  private static final int[][][] SENTE_DIRECT_MOVABLE_POSITIONS = {
    { {0,-1} }, // 
    { }, // 
    { {-1,-2}, {1,-2} }, // jn
    { {-1,-1}, {0,-1}, {1,-1}, {-1,1}, {1,1} }, // 
    { {-1,-1}, {0,-1}, {1,-1}, {-1,0}, {1,0}, {0,1} }, // 
    { }, // p
    { }, // 
    { {-1,-1}, {0,-1}, {1,-1},{-1,0}, {1,0}, {-1,1}, {0,1}, {1,1} }, // 
    { {0,-1}, {-1,0}, {1,0}, {0,1} }, // n
    { {-1,-1}, {1,-1}, {-1,1}, {1,1} }  // 
  };
    
  
  /**
   * ̋ڈړ\ȑΈʒuzB
   */
  private static final int[][][] GOTE_DIRECT_MOVABLE_POSITIONS = {
    { {0,1} }, // 
    { }, // 
    { {-1,2}, {1,2} }, // jn
    { {-1,1}, {0,1}, {1,1}, {-1,-1}, {1,-1} }, // 
    { {-1,1}, {0,1}, {1,1}, {-1,0}, {1,0}, {0,-1} }, // 
    { }, // p
    { }, // 
    { {-1,1}, {0,1}, {1,1}, {-1,0}, {1,0}, {-1,-1}, {0,-1}, {1,-1} }, // 
    { {0,1}, {-1,0}, {1,0}, {0,-1} }, // n
    { {-1,1}, {1,1}, {-1,-1}, {1,-1} }  // 
  };
    

  /**
   * \̔zB
   */
  
  private static final String[] KOMA_CHAR_ARRAY = new String[ 64 ];
  static {
	KOMA_CHAR_ARRAY[ Kyokumen.EMPTY ] = " @";
	KOMA_CHAR_ARRAY[ HU             ] = " ";
	KOMA_CHAR_ARRAY[ KYOU           ] = " ";
	KOMA_CHAR_ARRAY[ KEI            ] = " j";
	KOMA_CHAR_ARRAY[ GIN            ] = " ";
	KOMA_CHAR_ARRAY[ KIN            ] = " ";
	KOMA_CHAR_ARRAY[ KAKU           ] = " p";
	KOMA_CHAR_ARRAY[ HISYA          ] = " ";
	KOMA_CHAR_ARRAY[ OU             ] = " ";
	KOMA_CHAR_ARRAY[ HU    | NARI   ] = " ";
	KOMA_CHAR_ARRAY[ KYOU  | NARI   ] = " ";
	KOMA_CHAR_ARRAY[ KEI   | NARI   ] = " \";
	KOMA_CHAR_ARRAY[ GIN   | NARI   ] = " S";
	KOMA_CHAR_ARRAY[ KAKU  | NARI   ] = " n";
	KOMA_CHAR_ARRAY[ HISYA | NARI   ]= " ";

  	KOMA_CHAR_ARRAY[ Kyokumen.EMPTY | GOTE ] = "v@";
	KOMA_CHAR_ARRAY[ HU             | GOTE ] = "v";
	KOMA_CHAR_ARRAY[ KYOU           | GOTE ] = "v";
	KOMA_CHAR_ARRAY[ KEI            | GOTE ] = "vj";
	KOMA_CHAR_ARRAY[ GIN            | GOTE ] = "v";
	KOMA_CHAR_ARRAY[ KIN            | GOTE ] = "v";
	KOMA_CHAR_ARRAY[ KAKU           | GOTE ] = "vp";
	KOMA_CHAR_ARRAY[ HISYA          | GOTE ] = "v";
	KOMA_CHAR_ARRAY[ OU             | GOTE ] = "v";
	KOMA_CHAR_ARRAY[ HU    | NARI   | GOTE ] = "v";
	KOMA_CHAR_ARRAY[ KYOU  | NARI   | GOTE ] = "v";
	KOMA_CHAR_ARRAY[ KEI   | NARI   | GOTE ] = "v\";
	KOMA_CHAR_ARRAY[ GIN   | NARI   | GOTE ] = "vS";
	KOMA_CHAR_ARRAY[ KAKU  | NARI   | GOTE ] = "vn";
	KOMA_CHAR_ARRAY[ HISYA | NARI   | GOTE ]= "v";
}// static initializer
    
  /**
   * \intlA2̕ɕϊB
   * 
   * @param komaInfo ɕϊ̏B
   * @return \B
   */
  public static String toString( int komaInfo ) {
    
    return KOMA_CHAR_ARRAY[ komaInfo ];
    
  }// toString( int )
  

}// KomaUtil

// EOF