/*
 * Copyright (C) 2004 by X S ( Morioka Yuichi ) .
 *
 * 2004/09/18쐬B
 */
package jp.co.infoseek.hp.streakeagle.lib.shogi;


import jp.co.infoseek.hp.streakeagle.lib.util.*;

import java.util.*;


/**
 * ǖʁiՖʁEEԁj\NXB
 * 
 * @author X S ( Morioka Yuichi )
 * @version 1.0 
 * @since 1.0
 */
public class Kyokumen {



  /**
   * u̎_vu̎_v猩ǖʂ擾ׂ̃NXB
   * ǖʕ]ȂǂAEӎɏł悤ɂׂɎgpB
   * 
   * @author X S ( Morioka Yuichi )
   * @version 1.0 
   * @since 1.0
   */
  public interface View {
    
    
    /**
     * ̃r[̈ʒuƂāAՏ̃}X̏擾B
     * 
     * @param x ̃r[Ƃ؁B
     * @param y ̃r[ƂiB
     * @return Ŏw肵}X̏
     */
    public int getMasuInfo( int x, int y);
    
    
    /**
     * ͑̎̐擾B
     * 
     * @param self ̃r[̑ȂtrueÃr[̑葤ȂfalseB
     * @param komaType ̌^B
     * @return Ŏw肵E^́A̐B
     */
    public int getMochigomaInfo( boolean self, int komaType );
     
    
  }// View
  
  
  
  /**
   * ̎_̃r[񋟂NXB
   * 
   * @author X S ( Morioka Yuichi )
   * @version 1.0 
   * @since 1.0
   */
  private class SenteView implements View {


    /* ( Javadoc)
     * @see lib.shogi.Kyokumen.View#getMasuInfo(int, int)
     */
    public int getMasuInfo(int x, int y) {
      
      return Kyokumen.this.getMasuInfo( x, y );
      
    }// getMasuInfo(int,int);


    /* ( Javadoc)
     * @see lib.shogi.Kyokumen.View#getMochigomaInfo(boolean, int)
     */
    public int getMochigomaInfo(boolean self, int komaType) {
      
      return Kyokumen.this.getMochigomaNumber( self, komaType );
      
    }// getMochigomaInfo(boolean,int)
     

  }// SenteView
 
  
  /**
   * ̎_̃r[񋟂NXB
   * 
   * @author X S ( Morioka Yuichi )
   * @version 1.0 
   * @since 1.0
   */
  private class GoteView implements View {


    /* ( Javadoc)
     * @see lib.shogi.Kyokumen.View#getMasuInfo(int, int)
     */
    public int getMasuInfo(int x, int y) {
      
      return Kyokumen.this.getMasuInfo( 10 - x, 10 - y );
      
    }// getMasuInfo(int,int)
    

    /* ( Javadoc)
     * @see lib.shogi.Kyokumen.View#getMochigomaInfo(boolean, int)
     */
    public int getMochigomaInfo(boolean self, int komaType) {
      
      return Kyokumen.this.getMochigomaNumber( ! self, komaType );
      
    }// getMochigomaInfo(boolean,int)


  }// GoteView
  
  
  /**
   * 薔͌̃r[擾B
   * 
   * @param sente ȂtrueAȂfalseB
   * @return senteŎw肵̃r[B
   * @since 1.0
   */
  public View getView( boolean sente ) {
     
     return sente ? new SenteView() : new GoteView();
     
  }
  
  /**
   * ZOCێEǗׂ̃NXB
   * ǖʂς邽тZOC𐶐ĂƌvZԂ̃RXgނ̂ŁA{NXgpB
   * 
   * @author X S ( Morioka Yuichi )
   * @version 1.0 
   * @since 1.0
   */
  private class ZOCInformation {

    
    /** ZOCB */
    private int[][] senteZOCInfo = new int[ 9 ][ 9 ];
    
    
    /** ZOCB */
    private int[][] goteZOCInfo = new int[ 9 ][ 9 ];

    
    // /**
    // * ZOC - ZOCBɂƂĂǂقǗDB  
    // */
    // private int[][] totalZOCInfo = new int[ 9 ][ 9 ];
    
    
    /**
     * Ŏw肵̃vC[ZOC擾B
     * 
     * @param sente ȂtrueAȂfalseB
     * @return ZOCB
     */
    public int[][] getZOCInfo( boolean sente ) {
      
      return sente ? this.senteZOCInfo : this.goteZOCInfo;
      
    }// getZOCInfo(boolean)
    
    
    
        
    
    /**
     * ̔ԁEEpEnEԂ̘AZOCێ}bvB
     */
    private int[][] senteSequenceZOCInfo = new int[ 9 ][ 9 ];
    
    
    /**
     * ̔ԁEEpEnEԂ̘AZOCێ}bvB
     */
    private int[][] goteSequenceZOCInfo = new int[ 9 ][ 9 ];
    
    
    
    /* AZOC\萔BORŌ鎖ŁA̒ldˍ킹鎖łB */
    private static final int UP         = 1;               // 
    private static final int UP_RIGHT   = UP << 1;         // E
    private static final int RIGHT      = UP_RIGHT << 1;   // E
    private static final int DOWN_RIGHT = RIGHT << 1;      // E
    private static final int DOWN       = DOWN_RIGHT << 1; // 
    private static final int DOWN_LEFT  = DOWN << 1;       // 
    private static final int LEFT       = DOWN_LEFT << 1;  // 
    private static final int UP_LEFT    = LEFT << 1;       // 
    
    
    /**
     * GN[WOIuWFNg̃tB[hbanmenQƂāAZOCB
     */
    public void initialize() {
      
      // S؂ɑ΂ď
      for( int x = 1; x <= 9; x++ ) {
        
        // Siɑ΂ď
        for( int y = 1; y <= 9; y++ ) {
          
          int masuInfo = Kyokumen.this.getMasuInfo( x, y );
          
          // Տɋ΁AZOCɒǉ
          if( masuInfo != Kyokumen.EMPTY ) {
           
            this.putKoma( masuInfo, x, y );
            
          }// if(...)
          
        }// for(..y..)
        
      }// for(..x..)
      
    }// initialize()
    
    
    /**
     * xyiɋłB
     * 
     * @param komaInfo (Ȅ܂ށjB
     * @param x ؁B
     * @param y iB
     */
    public void putKoma( int komaInfo, int x, int y ) {

      
      
//      try { // for debug
        
       this.shortenSequenceZOC( x, y );
      
      
      // 肩肩ۑϐ
      boolean sente = KomaUtil.isSente( komaInfo ); 
      
      // ZOC̕ۑ
      int[][] currentZOCInfo = sente ? this.senteZOCInfo : this.goteZOCInfo;
      
      
      assert komaInfo != Kyokumen.EMPTY;
      
      // ڈړ\ȈʒũXg擾
      int[][] directMovablePositions = KomaUtil.getDirectMovablePositionArray( komaInfo );
      
//      System.err.println( "komaInfo : " + komaInfo ); // for debug
//      System.err.println( ArrayUtil.toString( directMovablePositions ) ); // for debug
      
      // ڈړ\ȃ}X邩ǂ
      if( directMovablePositions.length != 0 ) {
        
        // ڈړ\ȑSẴ}XɂČJԂ
        for( int i = 0; i < directMovablePositions.length; i++ ) {
          
          // ړ̋؁EiZOCɒǉ
          int postX = x + directMovablePositions[ i ][ 0 ];
          int postY = y + directMovablePositions[ i ][ 1 ];
          
//          System.err.println( "postX,postY : " + postX + "," + postY ); // for debug
          
          if( Kyokumen.this.getMasuInfo( postX, postY ) != Kyokumen.EDGE ) {
            
            currentZOCInfo[ postX - 1 ][ postY - 1 ]++;
            
          }// if(...)
          
        }// for(..i..)  SĂ̒ڈړ\ȃ}XɂČJԂ 
        
      }// if(...)  ڈړ\ۂ̔
      
      
      
      /* ڈړłȂȂAڍs̃R[hsȂ */
      int komaType = KomaUtil.getType( komaInfo );
      int komaArchetype = KomaUtil.getArchetype( komaInfo );
      
      if( komaType != KomaUtil.KYOU && komaArchetype != KomaUtil.HISYA && komaArchetype != KomaUtil.KAKU ) {
        
        return;
        
      }// if(...)
      
      int[][] sequenceZOCInfo = sente ? this.senteSequenceZOCInfo : this.goteSequenceZOCInfo;


      /* Ԃ̘AZOCݒ */ 
      if( KomaUtil.getType( komaInfo ) == KomaUtil.KYOU ) {

        // Õ}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
        int direction = sente ? UP : DOWN;
//        int postY = y + ( sente ? -1 : 1 );
//        sequenceZOCInfo[ x -1 ][ y - 1 ] |= direction;
        extendSequenceZOC( sequenceZOCInfo, direction, x, y, sente );

      }// if(...) Ԃǂ̔

      
      
      /* ԁE̘AZOCݒ */
      if( KomaUtil.getArchetype( komaInfo ) == KomaUtil.HISYA ) {

        if( y != 1 ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = UP;
//          sequenceZOCInfo[ x - 1 ][ y - 1 ] = direction;
          extendSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)
        
        if( y != 9 ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = DOWN;
//          sequenceZOCInfo[ x -1 ][ y - 1 ] = direction;
          extendSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)

        if( x != 1 ) {
          
          // Ẽ}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = RIGHT;
//          sequenceZOCInfo[ x - 1 ][ y - 1 ] |= direction;
          extendSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)
        
        if( x != 9 ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = LEFT;
//          sequenceZOCInfo[ x - 1 ][ y - 1 ] = direction;
          extendSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)
        
        return;

      }// if(...) ԁEǂ̔

      
      /* pEn̘AZOCݒ */
      if( KomaUtil.getArchetype( komaInfo ) == KomaUtil.KAKU ) {

        if( x != 1 && y != 1 ) {
          
          // Ẽ}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = UP_RIGHT;
//          sequenceZOCInfo[ x - 1 ][ y - 1 ] = direction;
          extendSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)
        
        if( x != 1 && y != 9 ) {
          
          // Ẽ}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = DOWN_RIGHT;
//          sequenceZOCInfo[ x - 1 ][ y - 1 ] = direction;
          extendSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)

        if( x != 9 && y != 9  ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = DOWN_LEFT;
//          sequenceZOCInfo[ x - 1 ][ y - 1 ] = direction;
          extendSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)
        
        if( x != 9 && y != 1 ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = UP_LEFT;
//          sequenceZOCInfo[ x - 1 ][ y - 1 ] = direction;
          extendSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)

      }// if(...) pEnǂ̔
      
      
//      } finally {

        /* for debug */
//        System.err.println( "Put : " + komaInfo + " at " + x + "," + y ); 
//        System.err.println( ArrayUtil.toString( senteZOCInfo ) );
//        System.err.println( ArrayUtil.toString( goteZOCInfo ) );
        //System.err.println( ArrayUtil.toString( Kyokumen.this.banmen ) );

        
//      }// try{...}  for debug

      
    }// pubKoma(int,int,int)
    
  
    
  
    /**
     * ̋ɓ邩ՊOɏo܂ŘAZOCB
     * 
     * @param sequenceZOCInfo AZOCۑĂzB
     * @param direction AZOC̕BtB[hUP,UP_RIGHT,...,UP_LEFTŎw肷B
     * @param initX ɂ؁B
     * @param initY ɂiB
     * @param sente ȂtrueAȂfalseB
     */
    private void extendSequenceZOC( int[][] sequenceZOCInfo, int direction, int initX, int initY, boolean sente) {

//      System.err.println( "extend ZOC from " + initX + "," + initY + "  " + (sente?"":"") + " to " + direction); // for debug
      
      // ؁Eï񂲂Ƃ̈ړ
      int dx = 0;
      int dy = 0;
      
      switch( direction ) {
      
        case UP:
          dy = -1;
          break;
          
        case UP_RIGHT:
          dx = -1;
          dy = -1;
          break;
          
        case RIGHT:
          dx = -1;
          break;
          
        case DOWN_RIGHT:
          dx = -1;
          dy = 1;
          break;
        
        case DOWN:
          dy = 1;
          break;
          
        case DOWN_LEFT:
          dx = 1;
          dy = 1;
          break;
          
        case LEFT:
          dx = 1;
          break;
          
        case UP_LEFT:
          dx = 1;
          dy = -1;
          break;

      }// switch(direction)
      
      
      
      // ZOCۑz
      int[][] currentZOCInfo = sente ? this.senteZOCInfo : this.goteZOCInfo; 
      
      
      // ɂ邩ՊOɏo܂ŌJԂ
      for( int x = initX + dx, y = initY + dy;
            true; 
            x += dx, y += dy ) {

//        System.err.println("A) x,y : " + x +","+ y ); // for debug

        if( Kyokumen.this.banmen[ x ][ y ] == Kyokumen.EDGE ) break; 

//        System.err.println("B) x,y : " + x +","+ y ); // for debug
        
        // AZOC͂ĂȂۂ𔻒
        if( ( sequenceZOCInfo[ x - 1 ][ y - 1 ] & direction ) == 0) {
        // if( true ) {
          
//          System.err.println("C) x,y : " + x +","+ y ); // for debug

          // xyiɁAAZOCǉ(̏ȂׂɁAORZg) 
          sequenceZOCInfo[ x - 1 ][ y - 1 ] |= direction;
        
          // ZOCCNg
          currentZOCInfo[ x - 1 ][ y - 1 ]++;

        }// if(...)
                
        // ̋ɂAŃuCN
        if( Kyokumen.this.banmen[ x ][ y ] != Kyokumen.EMPTY ) {
          
          break;
          
        }// if(...)
        
//        System.err.println("D) x,y : " + x +","+ y ); // for debug

        
        
      }// for(..x,y..)
        

//      System.err.println( "Extend complete." ); // for debug
//      System.err.println( ArrayUtil.toString( currentZOCInfo ) ); // for debug
      
    }// extendSequenceZOC(int[][],int,int,int)
    
    /**
     * Ŏw肵؁Eiɐݒ肳ĂAZOCA̋ɓ邩ՊOɏo܂ŉB
     * 
     * @param preX ɂ؁B
     * @param preY ɂiB
     */
   
    private void extendSequenceZOC( int preX, int preY ){
      
     
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP ) != 0 ) 
        this.extendSequenceZOC( this.senteSequenceZOCInfo, UP, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP_RIGHT ) != 0 ) 
        this.extendSequenceZOC( this.senteSequenceZOCInfo, UP_RIGHT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & RIGHT ) != 0 ) 
        this.extendSequenceZOC( this.senteSequenceZOCInfo, RIGHT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN_RIGHT ) != 0 ) 
        this.extendSequenceZOC( this.senteSequenceZOCInfo, DOWN_RIGHT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN ) != 0 ) 
        this.extendSequenceZOC( this.senteSequenceZOCInfo, DOWN, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN_LEFT ) != 0 ) 
        this.extendSequenceZOC( this.senteSequenceZOCInfo, DOWN_LEFT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & LEFT ) != 0 ) 
        this.extendSequenceZOC( this.senteSequenceZOCInfo, LEFT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP_LEFT ) != 0 ) 
        this.extendSequenceZOC( this.senteSequenceZOCInfo, UP_LEFT, preX, preY, true );
        
      
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP ) != 0 ) 
        this.extendSequenceZOC( this.goteSequenceZOCInfo, UP, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP_RIGHT ) != 0 ) 
        this.extendSequenceZOC( this.goteSequenceZOCInfo, UP_RIGHT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & RIGHT ) != 0 ) 
        this.extendSequenceZOC( this.goteSequenceZOCInfo, RIGHT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN_RIGHT ) != 0 ) 
        this.extendSequenceZOC( this.goteSequenceZOCInfo, DOWN_RIGHT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN ) != 0 ) 
        this.extendSequenceZOC( this.goteSequenceZOCInfo, DOWN, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN_LEFT ) != 0 ) 
        this.extendSequenceZOC( this.goteSequenceZOCInfo, DOWN_LEFT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & LEFT ) != 0 ) 
        this.extendSequenceZOC( this.goteSequenceZOCInfo, LEFT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP_LEFT ) != 0 ) 
        this.extendSequenceZOC( this.goteSequenceZOCInfo, UP_LEFT, preX, preY, false );
      
      
    }// extendSequenceZOC(int,int)
    
    /**
     * xyi̋ZOC폜B
     * 
     * @param x ؁B
     * @param y iB
     */
    public void removeKoma( int komaInfo, int x, int y ) {
      
      
//      System.err.println( "remove " + komaInfo + " from " + x + "," + y ); // for debug
      
//      // ̎o 
//      int komaInfo = Kyokumen.this.getMasuInfo( x, y );
      
      // 肩肩ۑϐ
      boolean sente = KomaUtil.isSente( komaInfo ); 
      
      // ZOC̕ۑ
      int[][] currentZOCInfo = sente ? this.senteZOCInfo : this.goteZOCInfo;
      
      
      assert komaInfo != Kyokumen.EMPTY : x + "," + y + "\n" +Kyokumen.this;
      
      // ڈړ\ȈʒũXg擾
      int[][] directMovablePositions = KomaUtil.getDirectMovablePositionArray( komaInfo );
      
      // ڈړ\ȃ}X邩ǂ
      if( directMovablePositions.length != 0 ) {
        
        // ڈړ\ȑSẴ}XɂČJԂ
        for( int i = 0; i < directMovablePositions.length; i++ ) {
          
          // ړ̋؁EiZOC񂩂폜
          int postX = x + directMovablePositions[ i ][ 0 ];
          int postY = y + directMovablePositions[ i ][ 1 ];
          
          if( Kyokumen.this.getMasuInfo( postX, postY ) != Kyokumen.EDGE ) {
            
//            System.err.println( "  remove ZOC from " + postX + "," + postY ); // for debug

            currentZOCInfo[ postX - 1 ][ postY - 1 ]--;
            
          }// if(...)
          
        }// for(..i..)  SĂ̒ڈړ\ȃ}XɂČJԂ 
        
      }// if(...)  ڈړ\ۂ̔
      
      
      
      /* ڈړłȂȂAڍs̃R[hsȂ */
      int komaType = KomaUtil.getType( komaInfo );
      int komaArchetype = KomaUtil.getArchetype( komaInfo );
      
      if( komaType != KomaUtil.KYOU && komaArchetype != KomaUtil.HISYA && komaArchetype != KomaUtil.KAKU ) {
        
        return;
        
      }// if(...)
      
      int[][] sequenceZOCInfo = sente ? this.senteSequenceZOCInfo : this.goteSequenceZOCInfo;


      /* Ԃ̘AZOC폜 */ 
      if( KomaUtil.getType( komaInfo ) == KomaUtil.KYOU ) {

        // Õ}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
        int direction = sente ? UP : DOWN;
        shortenSequenceZOC( sequenceZOCInfo, direction, x, y, sente );

      }// if(...) Ԃǂ̔

      
      
      /* ԁE̘AZOCݒ */
      if( KomaUtil.getArchetype( komaInfo ) == KomaUtil.HISYA ) {

        if( y != 1 ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = UP;
          //sequenceZOCInfo[ x - 1 ][ y - 2 ] = direction;
          shortenSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)
        
        if( y != 9 ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = DOWN;
          //sequenceZOCInfo[ x -1 ][ y ] = direction;
          shortenSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)

        if( x != 1 ) {
          
          // Ẽ}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = RIGHT;
          // sequenceZOCInfo[ x - 2 ][ y - 1 ] = direction;
          shortenSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)
        
        if( x != 9 ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = LEFT;
          // sequenceZOCInfo[ x ][ y - 1 ] = direction;
          shortenSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)
        
        return;

      }// if(...) ԁEǂ̔

      
      /* pEn̘AZOCݒ */
      if( KomaUtil.getArchetype( komaInfo ) == KomaUtil.KAKU ) {

        if( x != 1 && y != 1 ) {
          
          // Ẽ}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = UP_RIGHT;
          // sequenceZOCInfo[ x - 2 ][ y - 2 ] = direction;
          shortenSequenceZOC( sequenceZOCInfo, direction, x , y, sente );
          
        }// if(...)
        
        if( x != 1 && y != 9 ) {
          
          // Ẽ}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = DOWN_RIGHT;
          // sequenceZOCInfo[ x - 2 ][ y ] = direction;
          shortenSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)

        if( x != 9 && y != 9  ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = DOWN_LEFT;
          // sequenceZOCInfo[ x ][ y ] = direction;
          shortenSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)
        
        if( x != 9 && y != 1 ) {
          
          // ̃}XɘAZOCݒ肵Aړ\ȏ܂ŉ 
          int direction = UP_LEFT;
          // sequenceZOCInfo[ x ][ y - 2 ] = direction;
          shortenSequenceZOC( sequenceZOCInfo, direction, x, y, sente );
          
        }// if(...)

      }// if(...) pEnǂ̔

      
    }// removeKoma(x,y)
    

    
    /**
     * ɂ}Xȍ~̘AZOCZkB
     * 
     * @param sequenceZOCInfo AZOCۑĂzB
     * @param direction AZOC̕BtB[hUP,UP_RIGHT,...,UP_LEFTŎw肷B
     * @param initX ɂ؁B
     * @param initY ɂiB
     * @param sente ȂtrueAȂfalseB
     */
    private void shortenSequenceZOC( int[][] sequenceZOCInfo, int direction, int initX, int initY, boolean sente ) {
      
//      System.err.println( "shorten ZOC from " + initX + "," + initY + "  " + (sente?"":"") + " to " + direction); // for debug
  
      // ؁Eï񂲂Ƃ̈ړ
      int dx = 0;
      int dy = 0;
      
      switch( direction ) {
      
        case UP:
          dy = -1;
          break;
          
        case UP_RIGHT:
          dx = -1;
          dy = -1;
          break;
          
        case RIGHT:
          dx = -1;
          break;
          
        case DOWN_RIGHT:
          dx = -1;
          dy = 1;
          break;
        
        case DOWN:
          dy = 1;
          break;
          
        case DOWN_LEFT:
          dx = 1;
          dy = 1;
          break;
          
        case LEFT:
          dx = 1;
          break;
          
        case UP_LEFT:
          dx = 1;
          dy = -1;
          break;

      }// switch(direction)
            
      
      // ZOCۑz
      int[][] currentZOCInfo = sente ? this.senteZOCInfo : this.goteZOCInfo;
      
      

      // ɂ邩ՊOɏo܂ŌJԂ
      for( int x = initX + dx, y = initY + dy; true ; x += dx, y += dy ) {
        
        // [܂ŗAɃuCN
        if( Kyokumen.this.banmen[ x ][ y ] == Kyokumen.EDGE ) {
          
          break;
          
        }// if(...)
        
        
        // AZOC͂Ă邩ۂ𔻒
        if( ( sequenceZOCInfo[ x - 1 ][ y - 1 ] & direction ) != 0 ) {

//          System.err.println("C') x,y : " + x +","+ y ); // for debug

//          System.err.println( "\t pre  : " + sequenceZOCInfo [ x - 1 ][ y - 1 ] ); // for debug
          
          // xyiɁAAZOC폜(̏ȂׂɁA₱Z) 
          sequenceZOCInfo[ x - 1 ][ y - 1 ] &= direction ^ 0xFFFFFFFF; // directionrbg]ĂANDZ

//          System.err.println( "\t post : " + sequenceZOCInfo [ x - 1 ][ y - 1 ] ); // for debug
        
          //  ZOCfNg
          currentZOCInfo[ x - 1 ][ y - 1 ]--;
          
        }// if(...)
        
        
        // ̋ɂuCN 
        if( Kyokumen.this.banmen[ x ][ y ] != Kyokumen.EMPTY ) {
          
          break;
          
        }// if(...)
        
      }// for(..x,y..)
      
      
//      System.err.println( "Shorten complete." ); // for debug
//      System.err.println( ArrayUtil.toString( currentZOCInfo ) ); // for debug
 

    }// shortenSequenceZOC(int[][],int,int,int)

    
    
    /**
     * Ŏw肵؁Eiɐݒ肳Ă}X̘AZOCZkB
     * 
     * @param preX ɂ؁B
     * @param preY ɂiB
     */
    private void shortenSequenceZOC( int preX, int preY ){
      
     
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP ) != 0 ) 
        this.shortenSequenceZOC( this.senteSequenceZOCInfo, UP, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP_RIGHT ) != 0 ) 
        this.shortenSequenceZOC( this.senteSequenceZOCInfo, UP_RIGHT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & RIGHT ) != 0 ) 
        this.shortenSequenceZOC( this.senteSequenceZOCInfo, RIGHT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN_RIGHT ) != 0 ) 
        this.shortenSequenceZOC( this.senteSequenceZOCInfo, DOWN_RIGHT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN ) != 0 ) 
        this.shortenSequenceZOC( this.senteSequenceZOCInfo, DOWN, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN_LEFT ) != 0 ) 
        this.shortenSequenceZOC( this.senteSequenceZOCInfo, DOWN_LEFT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & LEFT ) != 0 ) 
        this.shortenSequenceZOC( this.senteSequenceZOCInfo, LEFT, preX, preY, true );
        
      if( ( this.senteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP_LEFT ) != 0 ) 
        this.shortenSequenceZOC( this.senteSequenceZOCInfo, UP_LEFT, preX, preY, true );
        
      
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP ) != 0 ) 
        this.shortenSequenceZOC( this.goteSequenceZOCInfo, UP, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP_RIGHT ) != 0 ) 
        this.shortenSequenceZOC( this.goteSequenceZOCInfo, UP_RIGHT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & RIGHT ) != 0 ) 
        this.shortenSequenceZOC( this.goteSequenceZOCInfo, RIGHT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN_RIGHT ) != 0 ) 
        this.shortenSequenceZOC( this.goteSequenceZOCInfo, DOWN_RIGHT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN ) != 0 ) 
        this.shortenSequenceZOC( this.goteSequenceZOCInfo, DOWN, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & DOWN_LEFT ) != 0 ) 
        this.shortenSequenceZOC( this.goteSequenceZOCInfo, DOWN_LEFT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & LEFT ) != 0 ) 
        this.shortenSequenceZOC( this.goteSequenceZOCInfo, LEFT, preX, preY, false );
        
      if( ( this.goteSequenceZOCInfo[ preX - 1 ][ preY - 1 ] & UP_LEFT ) != 0 ) 
        this.shortenSequenceZOC( this.goteSequenceZOCInfo, UP_LEFT, preX, preY, false );
      
      
    }// shortenSequenceZOC(int,int)
    
    
    /**
     * preXpreYiɂpostXpostYiɈړB
     * 
     * @param preKomaInfo  ړŐB
     * @param preX         ړŐ؁B
     * @param preY         ړO̒iB
     * @param postKomaInfo ړ̋B
     * @param postX        ړ̋؁B
     * @param postY        ړ̒iB
     */
    public void moveKoma( int preKomaInfo, int preX, int preY,int postKomaInfo, int postX, int postY ) {
      
//      System.err.println( preX +","+ preY +" -> "+ postX +","+ postY ); // for debug      
      
      this.shortenSequenceZOC( postX, postY );

      // ړÕ}XAZOC
      this.removeKoma( preKomaInfo, preX, preY );
//      if( Kyokumen.this.getMasuInfo( postX, postY ) != Kyokumen.EMPTY ) {
//        this.removeKoma( postX, postY );
//      }// if(...)
     
      // ړ̃}XZOCݒ肷
      this.putKoma( postKomaInfo, postX, postY );
      
      this.extendSequenceZOC( preX, preY );
      
    }// moveKoma(int,int,int,int,int,int)
    
    

    
    
  }// ZOCInformation

  
  /**
   * ZOCێB̃CX^XB
   */
  private final ZOCInformation ZOC_INFORMATION = new ZOCInformation();
  
  
  /**
   * {CX^Xɑ΂葤̃r[񋟂B̃CX^XB
   */
  private final View SENTE_VIEW = new SenteView();
    
    
  /**
   * {CX^Xɑ΂葤̃r[񋟂B̃CX^XB
   */
  private final View GOTE_VIEW = new GoteView();
    
    
  /**
   * Ŏw肵猩ViewCX^X𐶐B
   * 
   * @param sente 葤ȂtrueA葤ȂfalseB
   * @return ViewCX^XB
   */
  public View getViewInstance( boolean sente ) {
     
   return sente ? this.SENTE_VIEW : this.GOTE_VIEW; 
      
  }// getInstance(boolean)



  /**
   * ̃}Xɋ萔B
   */
  public static final int EMPTY = 0;
  
  
  /**
   * ̃}X"Ղ̊O"ł鎖萔B
   */
  public static final int EDGE = -1;

  
  /**
   * ՖʂێtB[hB
   */
  private int[][]banmen = new int[ 9+2 ][ 9+2 ]; // Ղ"["\ׂɁA2vf]ɗ̈B

  
  /**
   * E̋̏ێtB[hB
   */
  private int[][] komadai = new int[ 2 ][ 8 ]; 

  
  // ՖʂZOC̏B̔zu͕B
  {
    int x,y;
    
    // ㉺"["Ƀ}[NB
    for( x = 0; x < 9+2; x++ ) {
     
     this.banmen[ x ][ 0 ]  = EDGE;
     this.banmen[ x ][ 10 ] = EDGE;  
      
    }// for(..x..)
    
    
    // E"["Ƀ}[NB
    for( y = 0; y < 9+2; y++ ) {
      
      this.banmen[ 0 ][ y ]  = EDGE;
      this.banmen[ 10 ] [y ] = EDGE;
      
    }// for(..y..)
    
    
    // Ղ̒
    for( x = 1; x <= 9; x++ ) {
      for( y = 1; y <= 9; y++ ) {
        
        this.banmen[ x ] [ y ] = EMPTY;
        
      }// for(..y..)
      
    }// for(..x..)

    
    // ̋u
    this.banmen[ 1 ][ 9 ] = KomaUtil.KYOU;
    this.banmen[ 2 ][ 9 ] = KomaUtil.KEI;
    this.banmen[ 3 ][ 9 ] = KomaUtil.GIN;
    this.banmen[ 4 ][ 9 ] = KomaUtil.KIN;
    this.banmen[ 5 ][ 9 ] = KomaUtil.OU;
    this.banmen[ 6 ][ 9 ] = KomaUtil.KIN;
    this.banmen[ 7 ][ 9 ] = KomaUtil.GIN;
    this.banmen[ 8 ][ 9 ] = KomaUtil.KEI;
    this.banmen[ 9 ][ 9 ] = KomaUtil.KYOU;
    this.banmen[ 8 ][ 8 ] = KomaUtil.KAKU;
    this.banmen[ 2 ][ 8 ] = KomaUtil.HISYA;
    for( x = 1; x <= 9; x++ ) this.banmen[ x ][ 7 ] = KomaUtil.HU;

    // ̋uB
    this.banmen[ 1 ][ 1 ] = KomaUtil.KYOU  | KomaUtil.GOTE;
    this.banmen[ 2 ][ 1 ] = KomaUtil.KEI   | KomaUtil.GOTE;
    this.banmen[ 3 ][ 1 ] = KomaUtil.GIN   | KomaUtil.GOTE;
    this.banmen[ 4 ][ 1 ] = KomaUtil.KIN   | KomaUtil.GOTE;
    this.banmen[ 5 ][ 1 ] = KomaUtil.OU    | KomaUtil.GOTE;
    this.banmen[ 6 ][ 1 ] = KomaUtil.KIN   | KomaUtil.GOTE;
    this.banmen[ 7 ][ 1 ] = KomaUtil.GIN   | KomaUtil.GOTE;
    this.banmen[ 8 ][ 1 ] = KomaUtil.KEI   | KomaUtil.GOTE;
    this.banmen[ 9 ][ 1 ] = KomaUtil.KYOU  | KomaUtil.GOTE;
    this.banmen[ 2 ][ 2 ] = KomaUtil.KAKU  | KomaUtil.GOTE;
    this.banmen[ 8 ][ 2 ] = KomaUtil.HISYA | KomaUtil.GOTE;
    for( x = 1; x <= 9; x++ ) this.banmen[ x ][ 3 ] = KomaUtil.HU | KomaUtil.GOTE;
   
    // ̈ʒȕ
    this.senteOuX = 5;
    this.senteOuY = 9;
    this.goteOuX  = 5;
    this.goteOuY  = 1;

    
//    // l4
//    this.banmen[ 2 ][ 1 ] = KomaUtil.GIN;
//    this.banmen[ 2 ][ 5 ] = KomaUtil.HU;
//    this.banmen[ 3 ][ 4 ] = KomaUtil.KIN;
//    this.banmen[ 6 ][ 6 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 1 ][ 3 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 1 ][ 4 ] = KomaUtil.HU | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 2 ] = KomaUtil.HISYA | KomaUtil.GOTE;
//    
//    this.senteOuX = 6;
//    this.senteOuY = 6;
//    this.goteOuX = 1;
//    this.goteOuY = 3;
//    
//    this.komadai[0][KomaUtil.HU-1]    = 0;
//    this.komadai[0][KomaUtil.KEI-1]   = 0;
//    this.komadai[0][KomaUtil.KYOU-1]  = 0;
//    this.komadai[0][KomaUtil.GIN-1]   = 0;
//    this.komadai[0][KomaUtil.KIN-1]   = 1;
//    this.komadai[0][KomaUtil.KAKU-1]  = 0;
//    this.komadai[0][KomaUtil.HISYA-1] = 0;
//    this.komadai[1][KomaUtil.HU-1]    =1*0;
//    this.komadai[1][KomaUtil.KEI-1]   =1;
//    this.komadai[1][KomaUtil.KYOU-1]  =1*0;
//    this.komadai[1][KomaUtil.GIN-1]   =1;
//    this.komadai[1][KomaUtil.KIN-1]   =1;
//    this.komadai[1][KomaUtil.KAKU-1]  =1*0;
//    this.komadai[1][KomaUtil.HISYA-1] =1*0;


// l2    
//    this.banmen[ 7 ][ 2 ] = KomaUtil.HISYA;
//    this.banmen[ 6 ][ 2 ] = KomaUtil.KAKU;
//    this.banmen[ 6 ][ 6 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 1 ][ 1 ] = KomaUtil.KYOU | KomaUtil.GOTE;
//    this.banmen[ 1 ][ 3 ] = KomaUtil.HU | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 1 ] = KomaUtil.KEI | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 2 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 3 ] = KomaUtil.HU | KomaUtil.GOTE;
//    this.banmen[ 3 ][ 1 ] = KomaUtil.GIN | KomaUtil.GOTE;
//    this.banmen[ 3 ][ 4 ] = KomaUtil.HU | KomaUtil.GOTE;
//    this.banmen[ 4 ][ 1 ] = KomaUtil.KIN | KomaUtil.GOTE;
//    this.banmen[ 4 ][ 3 ] = KomaUtil.HU | KomaUtil.GOTE;
//
//    this.senteOuX = 6;
//    this.senteOuY = 6;
//    this.goteOuX = 2;
//    this.goteOuY = 2;
//    
//    this.komadai[0][KomaUtil.HU-1]    = 0;
//    this.komadai[0][KomaUtil.KEI-1]   = 0;
//    this.komadai[0][KomaUtil.KYOU-1]  = 0;
//    this.komadai[0][KomaUtil.GIN-1]   = 0;
//    this.komadai[0][KomaUtil.KIN-1]   = 0;
//    this.komadai[0][KomaUtil.KAKU-1]  = 0;
//    this.komadai[0][KomaUtil.HISYA-1] = 0;
//    this.komadai[1][KomaUtil.HU-1]    =14;
//    this.komadai[1][KomaUtil.KEI-1]   =3;
//    this.komadai[1][KomaUtil.KYOU-1]  =3;
//    this.komadai[1][KomaUtil.GIN-1]   =3;
//    this.komadai[1][KomaUtil.KIN-1]   =3;
//    this.komadai[1][KomaUtil.KAKU-1]  =1;
//    this.komadai[1][KomaUtil.HISYA-1] =1;

    
    //  l1    
//    this.banmen[ 3 ][ 3 ] = KomaUtil.HISYA;
//    this.banmen[ 4 ][ 4 ] = KomaUtil.KAKU;
//    this.banmen[ 7 ][ 7 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 1 ][ 1 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 1 ][ 2 ] = KomaUtil.KYOU | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 1 ] = KomaUtil.KEI | KomaUtil.GOTE;
//    this.banmen[ 4 ][ 1 ] = KomaUtil.KIN | KomaUtil.GOTE;
//
//    this.senteOuX = 7;
//    this.senteOuY = 7;
//    this.goteOuX = 1;
//    this.goteOuY = 1;
//    
//    this.komadai[0][KomaUtil.HU-1]    = 0;
//    this.komadai[0][KomaUtil.KEI-1]   = 0;
//    this.komadai[0][KomaUtil.KYOU-1]  = 0;
//    this.komadai[0][KomaUtil.GIN-1]   = 0;
//    this.komadai[0][KomaUtil.KIN-1]   = 0;
//    this.komadai[0][KomaUtil.KAKU-1]  = 0;
//    this.komadai[0][KomaUtil.HISYA-1] = 0;
//    this.komadai[1][KomaUtil.HU-1]    =2;
//    this.komadai[1][KomaUtil.KEI-1]   =0;
//    this.komadai[1][KomaUtil.KYOU-1]  =0;
//    this.komadai[1][KomaUtil.GIN-1]   =0;
//    this.komadai[1][KomaUtil.KIN-1]   =0;
//    this.komadai[1][KomaUtil.KAKU-1]  =0;
//    this.komadai[1][KomaUtil.HISYA-1] =0;


//    // l 5l3
//    this.banmen[ 7 ][ 7 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 1 ][ 3 ] = KomaUtil.HISYA | KomaUtil.NARI;
//    this.banmen[ 2 ][ 4 ] = KomaUtil.KEI;
//    this.banmen[ 2 ][ 1 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 2 ] = KomaUtil.HISYA | KomaUtil.GOTE;
//    this.banmen[ 3 ][ 3 ] = KomaUtil.GIN | KomaUtil.GOTE;
//    this.banmen[ 4 ][ 3 ] = KomaUtil.KAKU | KomaUtil.NARI | KomaUtil.GOTE;
//
//    this.senteOuX = 7;
//    this.senteOuY = 7;
//    this.goteOuX = 2;
//    this.goteOuY = 1;
//    
//    this.komadai[0][KomaUtil.HU-1]    = 0;
//    this.komadai[0][KomaUtil.KEI-1]   = 1;
//    this.komadai[0][KomaUtil.KYOU-1]  = 0;
//    this.komadai[0][KomaUtil.GIN-1]   = 0;
//    this.komadai[0][KomaUtil.KIN-1]   = 1;
//    this.komadai[0][KomaUtil.KAKU-1]  = 0;
//    this.komadai[0][KomaUtil.HISYA-1] = 0;
//    this.komadai[1][KomaUtil.HU-1]    =18;
//    this.komadai[1][KomaUtil.KEI-1]   =2;
//    this.komadai[1][KomaUtil.KYOU-1]  =4;
//    this.komadai[1][KomaUtil.GIN-1]   =3;
//    this.komadai[1][KomaUtil.KIN-1]   =3;
//    this.komadai[1][KomaUtil.KAKU-1]  =1;
//    this.komadai[1][KomaUtil.HISYA-1] =0;

//    // l 7l1
//    this.banmen[ 7 ][ 7 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 1 ][ 3 ] = KomaUtil.KAKU;
//    this.banmen[ 3 ][ 1 ] = KomaUtil.GIN;
//    this.banmen[ 5 ][ 2 ] = KomaUtil.KAKU;
//    this.banmen[ 2 ][ 3 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 5 ] = KomaUtil.HU | KomaUtil.GOTE;
//    this.banmen[ 3 ][ 2 ] = KomaUtil.GIN | KomaUtil.GOTE;
//    this.banmen[ 5 ][ 1 ] = KomaUtil.KEI | KomaUtil.GOTE;
//    this.banmen[ 5 ][ 4 ] = KomaUtil.HISYA | KomaUtil.NARI | KomaUtil.GOTE;
//
//    this.senteOuX = 7;
//    this.senteOuY = 7;
//    this.goteOuX = 2;
//    this.goteOuY = 3;
//    
//    this.komadai[0][KomaUtil.HU-1]    = 0;
//    this.komadai[0][KomaUtil.KEI-1]   = 0;
//    this.komadai[0][KomaUtil.KYOU-1]  = 0;
//    this.komadai[0][KomaUtil.GIN-1]   = 0;
//    this.komadai[0][KomaUtil.KIN-1]   = 1;
//    this.komadai[0][KomaUtil.KAKU-1]  = 0;
//    this.komadai[0][KomaUtil.HISYA-1] = 1;
//    this.komadai[1][KomaUtil.HU-1]    =17*0;
//    this.komadai[1][KomaUtil.KEI-1]   =3*0;
//    this.komadai[1][KomaUtil.KYOU-1]  =4*0;
//    this.komadai[1][KomaUtil.GIN-1]   =2*0;
//    this.komadai[1][KomaUtil.KIN-1]   =3*0;
//    this.komadai[1][KomaUtil.KAKU-1]  =0;
//    this.komadai[1][KomaUtil.HISYA-1] =0;

//    // l 9l1
//    this.banmen[ 7 ][ 7 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 1 ][ 1 ] = KomaUtil.KIN;
//    this.banmen[ 1 ][ 2 ] = KomaUtil.HU | KomaUtil.NARI;
//    this.banmen[ 3 ][ 5 ] = KomaUtil.KAKU;
//    this.banmen[ 5 ][ 1 ] = KomaUtil.HISYA;
//    this.banmen[ 3 ][ 1 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 1 ][ 3 ] = KomaUtil.KAKU | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 1 ] = KomaUtil.KEI | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 3 ] = KomaUtil.HU | KomaUtil.GOTE;
//    this.banmen[ 3 ][ 2 ] = KomaUtil.KIN| KomaUtil.GOTE;
//    this.banmen[ 3 ][ 3 ] = KomaUtil.GIN | KomaUtil.GOTE;
//    this.banmen[ 4 ][ 1 ] = KomaUtil.KEI | KomaUtil.GOTE;
//    this.banmen[ 5 ][ 4 ] = KomaUtil.HU | KomaUtil.GOTE;
//    this.banmen[ 6 ][ 2 ] = KomaUtil.HISYA  | KomaUtil.GOTE;
//
//    this.senteOuX = 7;
//    this.senteOuY = 7;
//    this.goteOuX = 3;
//    this.goteOuY = 1;
//    
//    this.komadai[0][KomaUtil.HU-1]    = 0;
//    this.komadai[0][KomaUtil.KEI-1]   = 0;
//    this.komadai[0][KomaUtil.KYOU-1]  = 0;
//    this.komadai[0][KomaUtil.GIN-1]   = 1;
//    this.komadai[0][KomaUtil.KIN-1]   = 0;
//    this.komadai[0][KomaUtil.KAKU-1]  = 0;
//    this.komadai[0][KomaUtil.HISYA-1] = 0;
//    this.komadai[1][KomaUtil.HU-1]    =15;
//    this.komadai[1][KomaUtil.KEI-1]   =2;
//    this.komadai[1][KomaUtil.KYOU-1]  =4;
//    this.komadai[1][KomaUtil.GIN-1]   =2;
//    this.komadai[1][KomaUtil.KIN-1]   =2;
//    this.komadai[1][KomaUtil.KAKU-1]  =0;
//    this.komadai[1][KomaUtil.HISYA-1] =0;


//    // l 11l1
//    this.banmen[ 8 ][ 8 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 2 ][ 1 ] = KomaUtil.KAKU;
//    this.banmen[ 3 ][ 3 ] = KomaUtil.KAKU;
//    this.banmen[ 3 ][ 4 ] = KomaUtil.GIN;
//    this.banmen[ 3 ][ 5 ] = KomaUtil.HISYA;
//    this.banmen[ 5 ][ 5 ] = KomaUtil.KEI;
//    this.banmen[ 1 ][ 3 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 1 ][ 1 ] = KomaUtil.KIN | KomaUtil.GOTE;
//    this.banmen[ 4 ][ 4 ] = KomaUtil.GIN | KomaUtil.GOTE;
//    this.banmen[ 7 ][ 2 ] = KomaUtil.HISYA  | KomaUtil.GOTE | KomaUtil.NARI;
//
//    this.senteOuX = 8;
//    this.senteOuY = 8;
//    this.goteOuX = 1;
//    this.goteOuY = 3;
//    
//    this.komadai[0][KomaUtil.HU-1]    = 0;
//    this.komadai[0][KomaUtil.KEI-1]   = 0;
//    this.komadai[0][KomaUtil.KYOU-1]  = 0;
//    this.komadai[0][KomaUtil.GIN-1]   = 0;
//    this.komadai[0][KomaUtil.KIN-1]   = 0;
//    this.komadai[0][KomaUtil.KAKU-1]  = 0;
//    this.komadai[0][KomaUtil.HISYA-1] = 0;
//    this.komadai[1][KomaUtil.HU-1]    =18;
//    this.komadai[1][KomaUtil.KEI-1]   =3;
//    this.komadai[1][KomaUtil.KYOU-1]  =4;
//    this.komadai[1][KomaUtil.GIN-1]   =2;
//    this.komadai[1][KomaUtil.KIN-1]   =3;
//    this.komadai[1][KomaUtil.KAKU-1]  =0;
//    this.komadai[1][KomaUtil.HISYA-1] =0;

//    // l 13l1
//    this.banmen[ 8 ][ 8 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 1 ][ 4 ] = KomaUtil.KAKU;
//    this.banmen[ 2 ][ 4 ] = KomaUtil.HU;
//    this.banmen[ 3 ][ 1 ] = KomaUtil.KAKU;
//    this.banmen[ 1 ][ 1 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 1 ][ 2 ] = KomaUtil.HISYA | KomaUtil.GOTE;
//    this.banmen[ 1 ][ 3 ] = KomaUtil.KIN | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 1 ] = KomaUtil.KEI  | KomaUtil.GOTE;
//
//    this.senteOuX = 8;
//    this.senteOuY = 8;
//    this.goteOuX = 1;
//    this.goteOuY = 1;
//    
//    this.komadai[0][KomaUtil.HU-1]    = 0;
//    this.komadai[0][KomaUtil.KEI-1]   = 1;
//    this.komadai[0][KomaUtil.KYOU-1]  = 0;
//    this.komadai[0][KomaUtil.GIN-1]   = 0;
//    this.komadai[0][KomaUtil.KIN-1]   = 1;
//    this.komadai[0][KomaUtil.KAKU-1]  = 0;
//    this.komadai[0][KomaUtil.HISYA-1] = 0;
//    this.komadai[1][KomaUtil.HU-1]    =17;
//    this.komadai[1][KomaUtil.KEI-1]   =2;
//    this.komadai[1][KomaUtil.KYOU-1]  =4;
//    this.komadai[1][KomaUtil.GIN-1]   =4;
//    this.komadai[1][KomaUtil.KIN-1]   =2;
//    this.komadai[1][KomaUtil.KAKU-1]  =0;
//    this.komadai[1][KomaUtil.HISYA-1] =1;

//    // l 15l1
//    this.banmen[ 8 ][ 8 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 1 ][ 2 ] = KomaUtil.HU;
//    this.banmen[ 2 ][ 4 ] = KomaUtil.HU;
//    this.banmen[ 2 ][ 5 ] = KomaUtil.KEI;
//    this.banmen[ 3 ][ 3 ] = KomaUtil.KAKU;
//    this.banmen[ 3 ][ 6 ] = KomaUtil.KEI;
//    this.banmen[ 4 ][ 1 ] = KomaUtil.GIN;
//    this.banmen[ 6 ][ 1 ] = KomaUtil.KAKU;
//    this.banmen[ 3 ][ 1 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 1 ][ 5 ] = KomaUtil.HISYA | KomaUtil.GOTE;
//    this.banmen[ 4 ][ 2 ] = KomaUtil.KYOU | KomaUtil.GOTE;
//    this.banmen[ 5 ][ 1 ] = KomaUtil.KIN  | KomaUtil.GOTE;
//    this.banmen[ 6 ][ 2 ] = KomaUtil.HISYA  | KomaUtil.GOTE | KomaUtil.NARI;
//
//    this.senteOuX = 8;
//    this.senteOuY = 8;
//    this.goteOuX = 3;
//    this.goteOuY = 1;
//    
//    this.komadai[0][KomaUtil.HU-1]    = 0;
//    this.komadai[0][KomaUtil.KEI-1]   = 2;
//    this.komadai[0][KomaUtil.KYOU-1]  = 0;
//    this.komadai[0][KomaUtil.GIN-1]   = 0;
//    this.komadai[0][KomaUtil.KIN-1]   = 0;
//    this.komadai[0][KomaUtil.KAKU-1]  = 0;
//    this.komadai[0][KomaUtil.HISYA-1] = 0;
//    this.komadai[1][KomaUtil.HU-1]    =16;
//    this.komadai[1][KomaUtil.KEI-1]   =0;
//    this.komadai[1][KomaUtil.KYOU-1]  =3;
//    this.komadai[1][KomaUtil.GIN-1]   =3;
//    this.komadai[1][KomaUtil.KIN-1]   =3;
//    this.komadai[1][KomaUtil.KAKU-1]  =0;
//    this.komadai[1][KomaUtil.HISYA-1] =0;

    // l 21l
//    this.banmen[ 4 ][ 4 ] = KomaUtil.HISYA;
//    this.banmen[ 7 ][ 5 ] = KomaUtil.KEI;
//    this.banmen[ 8 ][ 5 ] = KomaUtil.KAKU;
//    this.banmen[ 1 ][ 9 ] = KomaUtil.OU; // IWiɂ͖
//    this.banmen[ 3 ][ 2 ] = KomaUtil.GIN | KomaUtil.GOTE;
//    this.banmen[ 5 ][ 4 ] = KomaUtil.HISYA | KomaUtil.NARI | KomaUtil.GOTE;
//    this.banmen[ 6 ][ 1 ] = KomaUtil.OU | KomaUtil.GOTE;
//    this.banmen[ 6 ][ 2 ] = KomaUtil.HU | KomaUtil.GOTE;
//    this.banmen[ 7 ][ 3 ] = KomaUtil.GIN | KomaUtil.GOTE;
//    this.banmen[ 8 ][ 2 ] = KomaUtil.KAKU | KomaUtil.GOTE;
//
//    this.senteOuX = 1;
//    this.senteOuY = 9;
//    this.goteOuX = 6;
//    this.goteOuY = 1;
//    
//  this.komadai[0][KomaUtil.KEI-1] = 1;
//  this.komadai[0][KomaUtil.GIN-1] = 2;
//  this.komadai[0][KomaUtil.KIN-1] = 1;
//  this.komadai[1][KomaUtil.HU-1] =17;
//  this.komadai[1][KomaUtil.KEI-1] =2;
//  this.komadai[1][KomaUtil.KYOU-1] =4;
//  this.komadai[1][KomaUtil.KIN-1] =3;
    
// IWi21l    
//    // ̋u
//    this.banmen[ 3 ][ 3 ] = KomaUtil.KAKU | KomaUtil.NARI;
//    this.banmen[ 1 ][ 1 ] = KomaUtil.OU   | KomaUtil.GOTE;
//    this.banmen[ 2 ][ 2 ] = KomaUtil.KIN  | KomaUtil.GOTE;
//    this.banmen[ 4 ][ 1 ] = KomaUtil.KYOU | KomaUtil.GOTE;
//    this.banmen[1][9]     = KomaUtil.OU;// IWiɂ͖
//    
//    this.senteOuX = 1;
//    this.senteOuY = 9;
//    this.goteOuX = 1;
//    this.goteOuY = 1;
//    
//    
//    // ̏
//    this.komadai[0][KomaUtil.HU-1] = 2;
//    this.komadai[0][KomaUtil.KEI-1] = 1;
//    this.komadai[0][KomaUtil.KIN-1] = 1;
//    this.komadai[1][KomaUtil.HU-1] =16;
//    this.komadai[1][KomaUtil.KEI-1] =4;
//    this.komadai[1][KomaUtil.KYOU-1] =3;
//    this.komadai[1][KomaUtil.GIN-1] =4;
//    this.komadai[1][KomaUtil.KIN-1] =3;
//    this.komadai[1][KomaUtil.KAKU-1] =1;
//    this.komadai[1][KomaUtil.HISYA-1] =2;
    
    
    // ZOC̏
    this.ZOC_INFORMATION.initialize();
    
    
//    System.err.println( "Initializ Complete." ); // for debug
    
    
  }// initializer
   
  
  /**
   * Ŏw肵}X̏擾B
   * Ƃ͋AłȂƂ͖{NX̒萔̂ꂩԂB
   * 
   * @param x ؁B
   * @param y iB
   * @return w肵}X̏B̏ꍇ͐EAEs̏܂ށB
   */
  public int getMasuInfo( int x, int y ) {
    
    assert 0 <= x && x <= 10;
    assert 0 <= y && y <= 10; 
    
    return this.banmen[ x ][ y ];
    
  }// getMasuInfo(int,int) 
  

  /**
   * Ŏw肵}Xɏݒ肷B
   * łƂ͋AłȂƂ͖{NX̒萔̂ꂩƂēnB
   * 
   * @param masuInfo 񖔂͒萔B̏ꍇ͐EAEs̏܂ށB
   * @param x ؁B
   * @param y iB
   */
  @SuppressWarnings("unused")
private void setMasuInfo( int masuInfo, int x, int y ) {
    
    assert 1 <= x && x <= 9;
    assert 1 <= y && y <= 9; 
    
    this.banmen[ x ][ y ] = masuInfo;
    
  }// getMasuInfo(int,int) 
   
   

  /**
   * Ŏw肵̐擾B
   * 
   * @param sente ̎擾ƂtrueÂƂfalseB
   * @param komaType ̎ށBKomaUtilNX̃tB[hŎw肷B
   * @return ̐B
   */
  public int getMochigomaNumber( boolean sente, int komaType ) {
    
    assert 1 <= komaType && komaType <= 7;
    
    return this.komadai[ sente ? 0 : 1 ][ komaType - 1 ];
    
  }// getMochigomaNumber(boolean,int)


  /**
   * ԂێtB[hBԂȂtrueAԂȂfalseB
   */
  private boolean teban = true;


  /**
   * {CX^X̎Ԃ擾B
   * 
   * @return ȂtrueAȂfalseB
   */
  public boolean getTeban() {
    
    return this.teban;
    
  }// getTeban()
  
  
  
//  /**
//   * ̋ǖʂŎw̃XgB
//   * ǖʂɑ΂ĕ{@link #getApplicableTeList}\bhĂ΂鎖̂ŁALbVĂB
//   */
//  private List applicableTeList;
  
  
//  /**
//   * ݂̋ǖʂŁAsenteŎꂽw̃XgԂB
//   * 
//   * @param sente ȂtrueAȂfalseB
//   * @return w̃XgB
//   */
//  private List getApplicableTeList( boolean sente ) {
//    
//    // ݂̎ԂۑĂ
//    boolean originalTeban = this.teban;
//    
//    // ꎞIɐEŎw肳ꂽɕς
//    this.teban = sente;
//    
//    // w̃Xg擾
//    List result = this.getApplicableTeList();
//    
//    // ԂۑĂԂɖ߂
//    this.teban = originalTeban;
//    
//    return result;
//    
//  }// getApplicableTeList(boolean)
  
  
  /**
   * ݂̋ǖʂŎw̃XgԂB
   * 
   * @return w̃XgBevf{@link Te}NX̃CX^XB
   */
  public List<Te> getApplicableTeList() {

//  // w̃XgLbVĂ΁AԂ
//  if( this.applicableTeList != null ) {
//     return new ArrayList( this.applicableTeList );
//   }
    List<Te> resultList = new ArrayList<Te>();
    this.getApplicableTeList( resultList );
    return resultList;

  }// getApplicableTeList()
  

  /**
   * ݂̋ǖʂŎw̃XgԂB
   * {@link #getApplicableTeList()}ƈႢAListɎwi[̂ŁACX^X̃RXg𖳂oB
   * 
   * @param resultList ̃XgɎwi[B
   *                    ̃Xgɉ炩̗vfi[Ăꍇ́A̓NAB
   */
  public void getApplicableTeList( List<Te> resultList ) {

     assert resultList != null;
    
    // Ԃlɂ郊Xg
//    List result = new ArrayList();
    List<Te> result = resultList;
    result.clear();

    
    // S؂ɂČJԂ
    for( int x = 1; x <= 9; x++ ) {


      // `FbNptO
      boolean huExist = false;

      // SiɂČJԂ(`FbNp[`)
      for( int y = 1; y <= 9; y++ ) {

        // }X̏擾
        int masuInfo = this.getMasuInfo( x, y );

        // ԂĂ̕ł΁AtO𗧂ĂăuCN
        if( KomaUtil.isSente( masuInfo ) == this.teban
            && KomaUtil.getType( masuInfo ) == KomaUtil.HU ) {

          huExist = true;
          break;
            
        }// if(...)

      }// for(..y..)

      // SiɂČJԂ
     for( int y = 1; y <= 9; y++ ) {
       
       // }X̏擾
       int masuInfo = this.getMasuInfo( x, y );
       
       // }X󂢂Ă邩ǂ𔻒 
       if( masuInfo == EMPTY ) {

         /* 󂢂Ă}XȂAɑł𐶐 */
         

         // ͈iA͋iɕEłĂȂ̂ŁA`FbN
         if( ( this.teban && y != 1 ) || ( ! this.teban && y != 9 ) ) {

           // ̋؂Ɏ̕Aɕ邩ǂ𔻒
           if( ! huExist  &&  1 <= this.komadai[ this.teban ? 0 : 1 ][ KomaUtil.HU - 1 ] ) {
             
               /*****************************************/
               /* 2005/12/06 łl߂̃`FbN폜 */
               /*****************************************/
               
               // ̕łԂlɒǉ
               result.add( new Te( KomaUtil.HU | ( this.teban ? 0 : KomaUtil.GOTE ) ,
                                   Te.MOCHIGOMA, 0, x, y ) );
                 
           }// if(...)
               
           // ɍ邩ǂ𔻒
           if( 1 <= this.komadai[ this.teban ? 0 : 1 ][ KomaUtil.KYOU - 1 ] ) {
             
             // ̍łԂlɒǉ
             result.add( new Te( KomaUtil.KYOU | ( this.teban ? 0 : KomaUtil.GOTE ) ,Te.MOCHIGOMA, 0, x, y ) );
             
           }// if(...)

         }// if(...)

         
         // ͈EiA͔EiɌjłĂȂ̂ŁA`FbN
         if( ( this.teban && 3 <= y ) || ( ! this.teban && y <= 7  ) ){

           // Ɍj邩ǂ𔻒
           if( 1 <= this.komadai[ this.teban ? 0 : 1 ][ KomaUtil.KEI - 1 ] ) {

             // ̌jłԂlɒǉ
             result.add( new Te( KomaUtil.KEI | ( this.teban ? 0 : KomaUtil.GOTE ) ,Te.MOCHIGOMA, 0, x, y ) );

           }// if(...)

         }// if(...)

         
         // EEjESĂ̎ނ̎`FbN
         for( int koma = KomaUtil.GIN; koma <= KomaUtil.HISYA; koma++ ) {

           // 邩ǂ`FbN
           if( 1 <= this.komadai[ this.teban ? 0 : 1 ][ koma - 1 ] ){
             
             // łԂlɒǉ
             result.add( new Te( koma | ( this.teban ? 0 : KomaUtil.GOTE ) ,Te.MOCHIGOMA, 0, x, y ) );

           } // if(...)
           
         }// for(...)  
         
       } else {
         
         /* }Xɋꍇ */
         
         
         // ԂƈقȂ(̋)͈ړȂ̂Ŕ΂
         if( this.teban != KomaUtil.isSente( masuInfo ) ) {
           
           continue;
           
         }// if(...)
         
         
         // ڈړ\ȈʒũXg擾
         int[][] directMovablePositions = KomaUtil.getDirectMovablePositionArray( masuInfo );
         
         // ڈړ\ȃ}X邩ǂ
         if( directMovablePositions.length != 0 ) {
           
           // ڈړ\ȑSẴ}XɂČJԂ
           for( int i = 0; i < directMovablePositions.length; i++ ) {
             
             // ړ̋؁Eiyу}X擾
             int postX = x + directMovablePositions[ i ][ 0 ];
             int postY = y + directMovablePositions[ i ][ 1 ];
             int postMasuInfo = this.getMasuInfo( postX, postY );
             
             // ړ̃}X󂩓GȂړ\
             if( postMasuInfo == EMPTY 
                 || ( postMasuInfo != EDGE && ( this.teban != KomaUtil.isSente( postMasuInfo ) ) ) ) {
             
               // Eŕ
               if( this.teban ) {
                  
                 // ̏ꍇ
                 if( postY <= 3) {
                   
                    if(     ( KomaUtil.getType( masuInfo ) == KomaUtil.HU 
                           || KomaUtil.getType( masuInfo ) == KomaUtil.KYOU ) 
                        && postY == 1 ) {
                 
                       // ǉA[vs
                       result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );
                       continue;
                 
                    }// if(...) ̎ޔ 

                    if( KomaUtil.getType( masuInfo ) == KomaUtil.KEI 
                              && postY <= 2 ) {
                     
                     // ǉA[vs
                     result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );
                     continue;
                     
                   }// if(...) ̎ޔ 
                   
                   // ǉ
                   switch( KomaUtil.getType( masuInfo ) ) {
                      case KomaUtil.HU :
                      case KomaUtil.KEI :
                      case KomaUtil.GIN : 
                         result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );
                         break;
                     
                   }// switch(...)
                   
                   
                 } else if ( y == 3 && KomaUtil.getType( masuInfo ) == KomaUtil.GIN ) { // if(postY<=3)
                   
                   // ₪Đꍇ́Aǉ
                   result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );
                   
                 }// if(...) ꍇ
                 
                 // Ȃǉ
                 result.add( new Te( masuInfo, x, y, postX, postY ) );
                 
                 
               } else {
                 
                 // ̏ꍇ
                 if( 7 <= postY ) {
                   
                    if(    (    KomaUtil.getType( masuInfo ) == KomaUtil.HU 
                             || KomaUtil.getType( masuInfo ) == KomaUtil.KYOU ) 
                         && postY == 9 ) {
                 
                       // ǉA[vs
                       result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );
                       continue;
                 
                    }// if(...) ̎ޔ 

                    if( KomaUtil.getType( masuInfo ) == KomaUtil.KEI 
                              && 8 <= postY ) {
                     
                     // ǉA[vs
                     result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );
                     continue;
                     
                   }// if(...) ̎ޔ 
                   
                   // ǉ
                   switch( KomaUtil.getType( masuInfo ) ) {
                      case KomaUtil.HU :
                      case KomaUtil.KEI :
                      case KomaUtil.GIN : 
                         result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );
                         break;
                     
                   }// switch(...)
                   
                 } else if ( y == 7 && KomaUtil.getType( masuInfo ) == KomaUtil.GIN ) { // if(postY<=3)
                   
                   // ₪Đꍇ́Aǉ
                   result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );
                   
                 }// if(...) ꍇ
                 
                 // Ȃǉ
                 result.add( new Te( masuInfo, x, y, postX, postY ) );
                 
               }// if(...) E̔ 
               
             }// if(...)  ̃}Xɒڈړ\ۂ̔      
             
           }// for(..i..)  SĂ̒ڈړ\ȃ}XɂČJԂ 
           
         }// if(...)  ڈړ\ۂ̔
         
         
         /* Ԃ̈ړ */
         if( KomaUtil.getType( masuInfo ) == KomaUtil.KYOU ) {
           
           
           int dy = this.teban ? -1 : 1;// Öړ
           int postY = y + dy; // ړ̒i
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( x, postY );
             
             boolean breakFlag = false; 
             
             // ""ɓ˂ǂ
             if(  postMasuInfo != EMPTY ) {
               
               // ՊŐȂuCN
               if( ( postMasuInfo == EDGE ) || ( this.teban == KomaUtil.isSente( postMasuInfo ) ) ) {

                 break;
                 
               } else {
                 
                 // ̋ȂtO𗧂Ă
                 breakFlag = true;
                 
               }// if(...)
               
             }// if(...)
            
             // Ȃǉ
             if( ( this.teban && 2 <= postY ) || ( ( ! this.teban ) && postY <= 8 ) ) { // change to update != 1 -> == 3, != 9 -> == 7
             
               result.add( new Te( masuInfo, x, y, x, postY ) );
             
             }// if(..)
             
             // ǉ
             if( ( this.teban && postY <= 3 ) || ( ( ! this.teban ) && 7 <= postY  ) ) {
             
               result.add( new Te( masuInfo | KomaUtil.NARI, x, y, x, postY ) );
             
             }// if(..)
             
             // tOĂuCN
             if( breakFlag ) {
               
               break;
               
             }// if(...)
             
             postY += dy;
                             
           }// while(true)

           continue;
           
         }// if(...) Ԃǂ̔
         
         
         /* ԁËړ */
         if( KomaUtil.getArchetype( masuInfo ) == KomaUtil.HISYA ) {
           
           int dx;    // Ëړ
           int dy;    // Öړ
           int postX; // ړ̋
           int postY; // ړ̒i
           

           /* Oɐiޏꍇ */           
           dx = 0;
           dy = this.teban ? -1 : 1 ;
           
           postX = x;
           postY = y + dy;
           
           while( true ) {
             
             int postMasuInfo = this.getMasuInfo( postX, postY );
             
             boolean breakFlag = false; 
             
             // ""ɓ˂ǂ
             if(  postMasuInfo != EMPTY ) {
               
               // ՊŐȂuCN
               if( ( postMasuInfo == EDGE ) || ( this.teban == KomaUtil.isSente( postMasuInfo ) ) ) {

                 break;
                 
               } else {
                 
                 // ̋ȂtO𗧂Ă
                 breakFlag = true;
                 
               }// if(...)
               
             }// if(...)
            
             // 邩ۂ𔻒
             if(         ( this.teban   && ( postY <= 3 || y <= 3 )  ) 
                  || ( ( ! this.teban ) && ( 7 <= postY || 7 <= y ) ) ) {
             
                if( KomaUtil.getType( masuInfo ) == KomaUtil.HISYA ) {
                   
                 // ǉ
                 result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );

                }// if(...) 
                 
             }// if(...)

             // Ȃǉ
             result.add( new Te( masuInfo, x, y, postX, postY ) );

             
             // tOĂuCN
             if( breakFlag ) {
               
               break;
               
             }// if(...)
             
             postY += dy;
                             
           }// while(true)
           
           
           /* ɐiޏꍇ */
           dx = 0;
           dy = this.teban ? 1 : -1 ;
           
           postX = x;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY );
             
             boolean breakFlag = false; 
             
             // ""ɓ˂ǂ
             if(  postMasuInfo != EMPTY ) {
               
               // ՊŐȂuCN
               if( ( postMasuInfo == EDGE ) || ( this.teban == KomaUtil.isSente( postMasuInfo ) ) ) {

                 break;
                 
               } else {
                 
                 // ̋ȂtO𗧂Ă
                 breakFlag = true;
                 
               }// if(...)
               
             }// if(...)
            
            
             // 邩ۂ𔻒
              if(         ( this.teban   && y <= 3   ) 
                   || ( ( ! this.teban ) && 7 <= y )  ) {
             
                 if( KomaUtil.getType( masuInfo ) == KomaUtil.HISYA ) {
                   
                  // ǉ
                  result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );

                 }// if(...)
                 
               }// if(...)
                            
              // Ȃǉ
              result.add( new Te( masuInfo, x, y, postX, postY ) );
    
             
             // tOĂuCN
             if( breakFlag ) {
               
               break;
               
             }// if(...)
             
             postY += dy;
                             
           }// while(true)
           
           
           
           /* Eɐiޏꍇ */
           dx = -1;
           dy = 0 ;
           
           postX = x + dx;
           postY = y;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY );
             
             boolean breakFlag = false; 
             
             // ""ɓ˂ǂ
             if(  postMasuInfo != EMPTY ) {
               
               // ՊŐȂuCN
               if( ( postMasuInfo == EDGE ) || ( this.teban == KomaUtil.isSente( postMasuInfo ) ) ) {

                 break;
                 
               } else {
                 
                 // ̋ȂtO𗧂Ă
                 breakFlag = true;
                 
               }// if(...)
               
             }// if(...)
            
             // 邩ۂ𔻒
              if(         ( this.teban   && y <= 3   ) 
                   || ( ( ! this.teban ) && 7 <= y )  ) {
             
                 if( KomaUtil.getType( masuInfo ) == KomaUtil.HISYA ) {
                   
                  // ȂA𖳏Œǉ
                  result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );

                 } else { 
                 
                   // Ȃǉ
                   result.add( new Te( masuInfo, x, y, postX, postY ) );

                 
                 }// if(...)
                 
               } else {
                            
                 // Ȃǉ
                 result.add( new Te( masuInfo, x, y, postX, postY ) );

               }// if(...) 邩ǂ̔


             // tOĂuCN
             if( breakFlag ) {
               
               break;
               
             }// if(...)
             
             postX += dx;
                             
           }// while(true)
           
           
           /* ɐiޏꍇ */
           dx = 1;
           dy = 0;
           
           postX = x + dx;
           postY = y;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY );
             
             boolean breakFlag = false; 
             
             // ""ɓ˂ǂ
             if(  postMasuInfo != EMPTY ) {
               
               // ՊŐȂuCN
               if( ( postMasuInfo == EDGE ) || ( this.teban == KomaUtil.isSente( postMasuInfo ) ) ) {

                 break;
                 
               } else {
                 
                 // ̋ȂtO𗧂Ă
                 breakFlag = true;
                 
               }// if(...)
               
             }// if(...)
            
             // 邩ۂ𔻒
              if(         ( this.teban   && y <= 3   ) 
                   || ( ( ! this.teban ) && 7 <= y )  ) {
             
                 if( KomaUtil.getType( masuInfo ) == KomaUtil.HISYA ) {
                   
                  // ȂA𖳏Œǉ
                  result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );

                 } else { 
                 
                   // Ȃǉ
                   result.add( new Te( masuInfo, x, y, postX, postY ) );

                 
                 }// if(...)
                 
               } else {
                            
                 // Ȃǉ
                 result.add( new Te( masuInfo, x, y, postX, postY ) );
                                  
               }// if(...) 邩ǂ̔
             
             // tOĂuCN
             if( breakFlag ) {
               
               break;
               
             }// if(...)
             
             postX += dx;
                             
           }// while(true)


           continue;
           
         }// if(...) ԁEǂ̔
         
         
         /* pEn̈ړ */
         if( KomaUtil.getArchetype( masuInfo ) == KomaUtil.KAKU ) {
           
           int dx;    // Ëړ
           int dy;    // Öړ
           int postX; // ړ̋
           int postY; // ړ̒i
           

           /* EOɐiޏꍇ */           
           dx = -1;
           dy = this.teban ? -1 : 1 ;
           
           postX = x + dx;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY );
             
             boolean breakFlag = false; 
             
             // ""ɓ˂ǂ
             if(  postMasuInfo != EMPTY ) {
               
               // ՊŐȂuCN
               if( ( postMasuInfo == EDGE ) || ( this.teban == KomaUtil.isSente( postMasuInfo ) ) ) {

                 break;
                 
               } else {
                 
                 // ̋ȂtO𗧂Ă
                 breakFlag = true;
                 
               }// if(...)
               
             }// if(...)
            
             // 邩ۂ𔻒
             if(         ( this.teban   && ( postY <= 3 || y <= 3 )  ) 
                  || ( ( ! this.teban ) && ( 7 <= postY || 7 <= y ) ) ) {
             
               if( KomaUtil.getType( masuInfo ) == KomaUtil.KAKU ) {
                
                 // ǉ
                 result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );

               }// if(...)
             
             }

             // Ȃǉ
             result.add( new Te( masuInfo, x, y, postX, postY ) );
             
                          
             // tOĂuCN
             if( breakFlag ) {
               
               break;
               
             }// if(...)
             
             postX += dx;
             postY += dy;
                             
           }// while(true)
           
           
           /* Oɐiޏꍇ */           
           dx = 1;
           
           postX = x + dx;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY );
             
             boolean breakFlag = false; 
             
             // ""ɓ˂ǂ
             if(  postMasuInfo != EMPTY ) {
               
               // ՊŐȂuCN
               if( ( postMasuInfo == EDGE ) || ( this.teban == KomaUtil.isSente( postMasuInfo ) ) ) {

                 break;
                 
               } else {
                 
                 // ̋ȂtO𗧂Ă
                 breakFlag = true;
                 
               }// if(...)
               
             }// if(...)
            
             // 邩ۂ𔻒
             if(         ( this.teban   && ( postY <= 3 || y <= 3 )  ) 
                  || ( ( ! this.teban ) && ( 7 <= postY || 7 <= y ) ) ) {
             
               if( KomaUtil.getType( masuInfo ) == KomaUtil.KAKU ) {

                 // ǉ
                 result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );

               }// if(...)
             
             }// if(...)
                        
             // Ȃǉ
             result.add( new Te( masuInfo, x, y, postX, postY ) );
             
             // tOĂuCN
             if( breakFlag ) {
               
               break;
               
             }// if(...)
             
             postX += dx;
             postY += dy;
                             
           }// while(true)
           
                      
           /* Eɐiޏꍇ */
           dx = -1;
           dy = this.teban ? 1 : -1 ;
           
           postX = x + dx;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY );
             
             boolean breakFlag = false; 
             
             // ""ɓ˂ǂ
             if(  postMasuInfo != EMPTY ) {
               
               // ՊŐȂuCN
               if( ( postMasuInfo == EDGE ) || ( this.teban == KomaUtil.isSente( postMasuInfo ) ) ) {

                 break;
                 
               } else {
                 
                 // ̋ȂtO𗧂Ă
                 breakFlag = true;
                 
               }// if(...)
               
             }// if(...)
            

             // 邩ۂ𔻒
              if(         ( this.teban   && y <= 3   ) 
                   || ( ( ! this.teban ) && 7 <= y )  ) {
             
                 if( KomaUtil.getType( masuInfo ) == KomaUtil.KAKU ) {
                   
                  // ǉ
                  result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );

                 }// if(...)
                 
               }
            
              // Ȃǉ
              result.add( new Te( masuInfo, x, y, postX, postY ) );
               
             // tOĂuCN
             if( breakFlag ) {
               
               break;
               
             }// if(...)
             
             postX += dx;
             postY += dy;
                             
           }// while(true)
           


           /* ɐiޏꍇ */
           dx = 1;
           
           postX = x + dx;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY );
             
             boolean breakFlag = false; 
             
             // ""ɓ˂ǂ
             if(  postMasuInfo != EMPTY ) {
               
               // ՊŐȂuCN
               if( ( postMasuInfo == EDGE ) || ( this.teban == KomaUtil.isSente( postMasuInfo ) ) ) {

                 break;
                 
               } else {
                 
                 // ̋ȂtO𗧂Ă
                 breakFlag = true;
                 
               }// if(...)
               
             }// if(...)
            
             // 邩ۂ𔻒
              if(         ( this.teban   && y <= 3   ) 
                   || ( ( ! this.teban ) && 7 <= y )  ) {
             
                 if( KomaUtil.getType( masuInfo ) == KomaUtil.KAKU ) {
                   
                  // ǉ
                  result.add( new Te( masuInfo | KomaUtil.NARI, x, y, postX, postY ) );

                 }// if(...)
                 
              }// if(...)
            
              // Ȃǉ
              result.add( new Te( masuInfo, x, y, postX, postY ) );
               
             // tOĂuCN
             if( breakFlag ) {
               
               break;
               
             }// if(...)
             
             postX += dx;
             postY += dy;
                             
           }// while(true)

           continue;
           
         }// if(...) pEnǂ̔
         
         
       }// if(...) }X󂢂Ă邩ۂ̔
       
     }// for(..y..) 
      
    }// for(..x..)
       
//    return result; 
    
  }// getApplicableTeList(List)


  /**
   * ݂̋ǖʂŎw̃XgԂB
   * ݂̎Ԃ𖳎āAsenteŎw肵̎w̃Xg𐶐B
   * 
   * @param list w̃XgɕۊǂB
   * @param sente ̎w𐶐ȂtrueAȂfalseB
   * @since 1.0
   */
  public void getApplicableTeList( List<Te> list, boolean sente ) {
     
     // ݂̎ԂۑĂ
     boolean oldTeban = this.teban;
     
     this.teban = sente;
     
     this.getApplicableTeList( list );
     
     this.teban = oldTeban;
  
  }// getApplicableTeList(List<Te>,boolean)


  /**
   * Ŏw肵肪݂̋ǖʂŎw邩ۂԂB
   * 
   * @param te w邩ۂ𔻒肵B
   * @return wȂtrueAwȂȂfalseB
   */
  public boolean isApplicable( Te te ) {
    
    return this.getApplicableTeList().contains( te );
    
  }// isApplicable(Te)

  
  /**
   * senteŎw肵̃vC[ZOC(<i>Zone Of Control</i>)̏擾B
   * Ԃl<i>[x][y]</i>vfɂxyĩ}XɈړ\ȋ̐ۑĂB
   * 
   * @param sente ȂtrueAȂfalseB
   * @return ZOCBvf9x9B
   */
  public int[][] getZOCInfo( boolean sente ) {
    
    int[][] result = this.ZOC_INFORMATION.getZOCInfo( sente ); 
    
    assert ArrayUtil.equals2D( result, this.getZOCInfo_old( sente )  ) : this + "\n" + ( sente ? "" : "" ) + "ZOC\n" + ArrayUtil.toString( result ) + "\n" + ArrayUtil.toString(this.getZOCInfo_old( sente ));
    
    return result;
    
  }// getZOCInfo(boolean)
  

  /**
   * senteŎw肵̃vC[ZOC(<i>Zone Of Control</i>)̏擾B
   * Ԃl<i>[x][y]</i>vfɂxyĩ}XɈړ\ȋ̐ۑĂB
   * <p>
   * <b>{\bh͌ÂȂ̂ŁAgp𐄏ȂB</b>
   * 
   * @param sente ȂtrueAȂfalseB
   * @return ZOCBvf9x9B
   */
  public int[][] getZOCInfo_old( boolean sente ) {

    // ZOC̕ۑ
    int[][] currentZOC = new int[ 9 ][ 9 ];
    
    // S؂ɂČJԂ
    for( int x = 1; x <= 9; x++ ) {

      // SiɂČJԂ
     for( int y = 1; y <= 9; y++ ) {
       
       //System.err.println( x +","+ y );
       
       // }X̏擾
       int masuInfo = this.getMasuInfo( x, y );
       
       // 󂢂Ă}XƈsenteŎw肳ꂽ̂Ƃ͋t̃vC[͖̋
       if( masuInfo == Kyokumen.EMPTY || ( KomaUtil.isSente( masuInfo ) != sente  ) ) {

         continue;

       }// if(...)
         
         
       // ڈړ\ȈʒũXg擾
       int[][] directMovablePositions = KomaUtil.getDirectMovablePositionArray( masuInfo );
         
       // ڈړ\ȃ}X邩ǂ
       if( directMovablePositions.length != 0 ) {
           
         // ڈړ\ȑSẴ}XɂČJԂ
         for( int i = 0; i < directMovablePositions.length; i++ ) {
           
           // ړ̋؁EiZOCɒǉ
           int postX = x + directMovablePositions[ i ][ 0 ];
           int postY = y + directMovablePositions[ i ][ 1 ];
           
//           System.err.println(masuInfo + "("+ postX +","+ postY +")"); // for debug
           
           if( this.getMasuInfo( postX, postY ) != Kyokumen.EDGE ) {

             currentZOC[ postX - 1 ][ postY - 1 ]++;
             
           }// if(...)

         }// for(..i..)  SĂ̒ڈړ\ȃ}XɂČJԂ 
           
       }// if(...)  ڈړ\ۂ̔
         
       
       
       /* ڈړłȂȂAڍs̃R[hsȂ */
       int komaType = KomaUtil.getType( masuInfo );
       int komaArchetype = KomaUtil.getArchetype( masuInfo );
       
       if( komaType != KomaUtil.KYOU && komaArchetype != KomaUtil.HISYA && komaArchetype != KomaUtil.KAKU ) {
        
        continue; 
         
       }// if(...)
       
         
         
       /* Ԃ̈ړ */
       if( KomaUtil.getType( masuInfo ) == KomaUtil.KYOU ) {
           
           
           int dy = KomaUtil.isSente( masuInfo ) ? -1 : 1;// Öړ
           
         int postY = y + dy;

         while( true ) {
           
//           System.err.println( postY ); 

          int postMasuInfo = this.getMasuInfo( x, postY ); 

           // ՊOɏouCN
           if( postMasuInfo == Kyokumen.EDGE ) {

             break;
               
           }// if(...)


             currentZOC[ x - 1 ][ postY - 1 ]++;
             
             // ""ɓ˂uCN
             if( postMasuInfo != Kyokumen.EMPTY ) {
               
               break;
               
             }// if(...)
             
             postY += dy;
             
           }// while(true)
         
         continue;
         
       }// if(...) Ԃǂ̔
         
         
       // System.err.println( "ԁE" );
         
       /* ԁËړ */
       if( KomaUtil.getArchetype( masuInfo ) == KomaUtil.HISYA ) {
         
         int dx;    // Ëړ
         int dy;    // Öړ
         int postX; // ړ̋
         int postY; // ړ̒i
         
         
         /* Oɐiޏꍇ */           
         dx = 0;
         dy = KomaUtil.isSente( masuInfo ) ? -1 : 1 ;
         
         postX = x;
         postY = y + dy;
         
         while( true ) {
           
           int postMasuInfo = this.getMasuInfo( postX, postY ); 
           
           
           // ՊOɏouCN
           if( postMasuInfo == Kyokumen.EDGE ) {

             break;
               
           }// if(...)


           currentZOC[ postX - 1 ][ postY - 1 ]++;
           
           // ""ɓ˂uCN
           if( postMasuInfo != Kyokumen.EMPTY ) {
               
             break;
                 
           }// if(...)
           
           postY += dy;
           
         }// while(true)
           
         
         /* ɐiޏꍇ */
         dx = 0;
         dy = KomaUtil.isSente( masuInfo ) ? 1 : -1 ;
           
           postX = x;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY ); 
            
             
             // ՊOɏouCN
             if( postMasuInfo == Kyokumen.EDGE ) {

               break;
               
             }// if(...)


             currentZOC[ postX - 1 ][ postY - 1 ]++;

             // ""ɓ˂uCN
             if( postMasuInfo != Kyokumen.EMPTY ) {

               break;
                 
             }// if(...)

             postY += dy;

           }// while(true)
           
           
           
           /* Eɐiޏꍇ */
           dx = -1;
           dy = 0 ;
           
           postX = x + dx;
           postY = y;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY ); 


             // ՊOɏouCN
             if( postMasuInfo == Kyokumen.EDGE ) {

               break;
               
             }// if(...)


           currentZOC[ postX - 1 ][ postY - 1 ]++;

             // ""ɓ˂uCN
             if( postMasuInfo != Kyokumen.EMPTY ) {

               break;
                 
             }// if(...)
             
             postX += dx;
                             
           }// while(true)
           
           
           /* ɐiޏꍇ */
           dx = 1;
           dy = 0;
           
           postX = x + dx;
           postY = y;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY ); 
             
             // ՊOɏouCN
             if( postMasuInfo == Kyokumen.EDGE ) {

               break;
               
             }// if(...)


             currentZOC[ postX - 1 ][ postY - 1 ]++;
             
             // ""ɓ˂uCN
             if( postMasuInfo != Kyokumen.EMPTY ) {
               
               break;
               
             }// if(...)
             
             postX += dx;
             
           }// while(true)
         
         
         continue;
           
       }// if(...) ԁEǂ̔
         
       //System.err.println( "pEn" );

         
         /* pEn̈ړ */
         if( KomaUtil.getArchetype( masuInfo ) == KomaUtil.KAKU ) {
           
           int dx;    // Ëړ
           int dy;    // Öړ
           int postX; // ړ̋
           int postY; // ړ̒i
           

           /* EOɐiޏꍇ */           
           dx = -1;
           dy = KomaUtil.isSente( masuInfo ) ? -1 : 1 ;
           
           postX = x + dx;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY ); 

             // ՊOɏouCN
             if( postMasuInfo == Kyokumen.EDGE ) {

               break;
               
             }// if(...)


             currentZOC[ postX - 1 ][ postY - 1 ]++;

             // ""ɓ˂uCN
             if( postMasuInfo != Kyokumen.EMPTY ) {

               break;
               
             }// if(...)



             
             postX += dx;
             postY += dy;
                             
           }// while(true)
           
           
           /* Oɐiޏꍇ */
           dx = 1;
           
           postX = x + dx;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY ); 

             // ՊOɏouCN
             if( postMasuInfo == Kyokumen.EDGE ) {

               break;
               
             }// if(...)


             currentZOC[ postX - 1 ][ postY - 1 ]++;

             // ""ɓ˂uCN
             if( postMasuInfo != Kyokumen.EMPTY ) {
               
               break;
               
             }// if(...)

             
             postX += dx;
             postY += dy;
                             
           }// while(true)
           
                      
           /* Eɐiޏꍇ */
           dx = -1;
           dy = KomaUtil.isSente( masuInfo ) ? 1 : -1 ;
           
           postX = x + dx;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY ); 

             // ՊOɏouCN
             if( postMasuInfo == Kyokumen.EDGE ) {

               break;
               
             }// if(...)


             currentZOC[ postX - 1 ][ postY - 1 ]++;

             // ""ɓ˂uCN
             if( postMasuInfo != Kyokumen.EMPTY ) {

               break;
               
             }// if(...)
             
             postX += dx;
             postY += dy;
                             
           }// while(true)
           


           /* ɐiޏꍇ */
           dx = 1;
           
           postX = x + dx;
           postY = y + dy;
           
           while( true ) {

             int postMasuInfo = this.getMasuInfo( postX, postY ); 

             // ՊOɏouCN
             if( postMasuInfo == Kyokumen.EDGE ) {

               break;
               
             }// if(...)


             currentZOC[ postX - 1 ][ postY - 1 ]++;

             // ""ɓ˂uCN
             if( postMasuInfo != Kyokumen.EMPTY ) {

               break;
               
             }// if(...)
             
             postX += dx;
             postY += dy;
                             
           }// while(true)

           continue;
           
         }// if(...) pEnǂ̔
       
     }// for(..y..) 
      
    }// for(..x..)
        
    return currentZOC;
    
  }// getZOCInfo(boolean)

  
  /**
   * {@link #rollback}\bhŎgpێ郊XgB
   * evf{@link RollbackEntry}NX̃CX^XB
   */
  private List<RollbackEntry> rollbackInformation = new ArrayList<RollbackEntry>();
  
  
  /**
   * 蕪{@linkplain #rollback [obN}ێGg[B
   * 
   * @author X S ( Morioka Yuichi )
   * @version 1.0 
   * @since 1.0
   */
  private static class RollbackEntry {
    
    
    /**
     * ړŐ؁B
     */
    public final int preX;
    
    
    /**
     * ړO̒iB
     */
    public final int preY;
    
    
    /**
     * ړŐB
     */
    public final int preKomaInfo;
    
    
    /**
     * ړ̋؁B
     */
    public final int postX;
    
    
    /**
     * ړ̒iB
     */
    public final int postY;
    
    
    /**
     * ړ̃}XB
     */
    public final int postMasuInfo;
    

    /**
     * ew肵āAVCX^X𐶐B
     * 
     * @param preX         ړŐ؁B
     * @param preY         ړO̒iB
     * @param preKomaInfo  ړŐB
     * @param postX        ړ̋؁B
     * @param postY        ړ̒iB
     * @param postMasuInfo ړ̃}XB
     */    
    public RollbackEntry( int preX, int preY, int preKomaInfo, int postX, int postY, int postMasuInfo ) {
      
      this.preX         = preX;
      this.preY         = preY;
      this.preKomaInfo  = preKomaInfo;
      this.postX        = postX;
      this.postY        = postY;
      this.postMasuInfo = postMasuInfo;
      
    }// RollbackEntry(int,int,int,int,int,int)
    
    
    public String toString() {
       
       return "(" + preX + "," + preY + ") " + preKomaInfo + " -> (" + postX + "," + postY + ") " + postMasuInfo; 
       
    }

    
  }// RollbackEntry
  
  
  /**
   * Ŏw肵wB
   * 
   * @param te wB
   */
  public void apply( Te te ) {

     assert te != null;
     assert this.isApplicable( te ) : this.toString() + te.toString();
     
//     System.err.println("AvC");
     
     // 𓮂ꍇ́ÄʒuύX
     if( KomaUtil.getType( te.komaInfo ) == KomaUtil.OU ) {
        
//        System.err.println("ړ ->" + te.postX +","+ te.postY );
        
        // Eŕ
        if( this.teban ) { 
           
           this.senteOuX = te.postX;
           this.senteOuY = te.postY;
           
        } else {
           
           this.goteOuX = te.postX;
           this.goteOuY = te.postY;
           
        }// if(...)
        
     }// 𓮂ꍇ
  
//    // w̃XgNA
//    this.applicableTeList = null;
    

//    System.err.println( te );

    // ړ̏ꏊɂ̏
    int komaAtPostPosition =this.getMasuInfo( te.postX, te.postY );
    
        

    // łꍇǂ𔻒
    if( te.preX == Te.MOCHIGOMA ) {
      // łꍇ

      assert komaAtPostPosition == EMPTY;
      assert ( te.komaInfo & KomaUtil.NARI ) != KomaUtil.NARI;
      assert 1 <= this.komadai[ this.teban ? 0 : 1 ][ KomaUtil.getType( te.komaInfo ) - 1 ];

      // [obNpۑ
      this.rollbackInformation.add( new RollbackEntry( te.preX, te.preY, te.komaInfo, 
                                                       te.postX, te.postY, this.banmen[ te.postX ][ te.postY ] ) );

      // ړ
      this.banmen[ te.postX ][ te.postY ] = te.komaInfo;

      // 炷
      this.komadai[ this.teban ? 0 : 1 ][ KomaUtil.getType( te.komaInfo ) - 1 ]--;

      
      // ZOCXV
      this.ZOC_INFORMATION.putKoma( te.komaInfo, te.postX, te.postY );

      
    } else {
      // Տ̋𓮂ꍇ
      
      // [obNpۑ
      this.rollbackInformation.add( new RollbackEntry( te.preX, te.preY, this.banmen[ te.preX ][ te.preY ], 
                                                       te.postX, te.postY, this.banmen[ te.postX ][ te.postY ] ) );

      //    ړ̏ꏊɋ邩ǂ 
      if( komaAtPostPosition != EMPTY ) {
        
        assert this.teban != KomaUtil.isSente( komaAtPostPosition );
        
        // ړ̏ꏊɂɈړ
        this.komadai[ this.teban ? 0 : 1 ][ KomaUtil.getArchetype( komaAtPostPosition ) - 1 ]++;
        
        // ZOCXV
        this.ZOC_INFORMATION.removeKoma( komaAtPostPosition, te.postX, te.postY );
        
      }// if(...)
      
      // ړŐ擾
      int preKomaInfo = this.banmen[ te.preX  ][ te.preY  ];
      
      // ̂ꏊ󂫃}Xɂ
      this.banmen[ te.preX  ][ te.preY  ] = EMPTY;
      
      
      // ړ
      this.banmen[ te.postX ][ te.postY ] = te.komaInfo;
      
      // ZOCXV
      this.ZOC_INFORMATION.moveKoma( preKomaInfo, te.preX, te.preY, te.komaInfo, te.postX, te.postY );


    }// if(...)

    
    
    // Eւ
    this.teban = ! this.teban;
    
  }// apply(Te)


  /**
   * CX^X̕ێŐǖʂɖ߂B
   */
  public void rollback() {

//    if( true ) {
//      System.out.println( "rollback" ); // for debug
//      System.exit(0);
//    }
    
//    // w̃XgNA
//    this.applicableTeList = null;


    // [obNp̎o&폜
    RollbackEntry entry = ( RollbackEntry ) this.rollbackInformation.get( this.rollbackInformation.size() - 1 );
    this.rollbackInformation.remove( this.rollbackInformation.size() - 1 );    
    
    assert Te.MOCHIGOMA <= entry.preX && entry.preX <= 9;
    assert 0 <= entry.preY && entry.preY <= 9;
    assert 1 <= entry.postX && entry.postY <= 9;
    assert 1 <= entry.postY && entry.postY <= 9;
    assert entry.preKomaInfo != EMPTY && entry.preKomaInfo != EDGE;
    assert KomaUtil.isSente( entry.preKomaInfo ) != this.teban : this +"\n"+ entry;
    assert entry.postMasuInfo != EDGE;
    assert entry.postMasuInfo == EMPTY || KomaUtil.isSente( entry.postMasuInfo ) == this.teban;

//    System.err.println( "[obN" );
    
    // 𓮂ꍇ́ÄʒuύX
    if( KomaUtil.getType( entry.preKomaInfo ) == KomaUtil.OU ) {
//    if( entry.preKomaInfo == KomaUtil.OU ) { // for debug (temporary)
            
//       System.err.println( "̈ʒu[obN" + senteOuX +","+ senteOuY +"->"+ entry.preX +","+ entry.preY);
       
       // Eŕ
       if( !this.teban ) {
          
          this.senteOuX = entry.preX;
          this.senteOuY = entry.preY;
          
       } else {
          
          this.goteOuX = entry.preX;
          this.goteOuY = entry.preY;
          
       }// if(...)
       
    }// 𓮂ꍇ

//    System.err.println( "[obNi2j" );
    
//    System.out.println( entry.preX + "," + entry.preY + " : " + KomaUtil.toString( entry.preKomaInfo ) ); // for debug
//    System.out.println( entry.postX + "," + entry.postY + " : " +KomaUtil.toString( entry.postMasuInfo ) ); // for debug


    // łՏ̋𓮂𔻒
    if( entry.preX == Te.MOCHIGOMA ) {
      // łꍇ

      // ł菜
      this.banmen[ entry.postX ][ entry.postY ] = EMPTY;

      // ₷
      this.komadai[ this.teban ? 1 : 0 ][ KomaUtil.getArchetype( entry.preKomaInfo ) - 1 ]++;
      
      
      // ZOCXV
      this.ZOC_INFORMATION.removeKoma( entry.preKomaInfo, entry.postX, entry.postY );
      this.ZOC_INFORMATION.extendSequenceZOC( entry.postX, entry.postY );

      

    } else {
      // Տ̋𓮂ꍇ
      
      int postKomaInfoBeforeRollback = this.banmen[ entry.postX ][ entry.postY ];

/*      System.err.println( "[obN" + entry.postX +","+ entry.postY +"("+ entry.postMasuInfo +")" 
            +"->"+ 
            entry.preX +","+ entry.preY +"("+ entry.preKomaInfo +")" );
*/
      // Տ̏ɖ߂
      this.banmen[ entry.preX ][ entry.preY ]   = entry.preKomaInfo;
      this.banmen[ entry.postX ][ entry.postY ] = entry.postMasuInfo;

/*      System.err.println( "[obN" + entry.postX +","+ entry.postY +"("+ entry.postMasuInfo +")" 
            +"->"+ 
            entry.preX +","+ entry.preY +"("+ entry.preKomaInfo +")" );
*/

      //      System.err.println( this.banmen[ entry.preX ][ entry.preY ] +","+ entry.preKomaInfo );
      
      /* ZOCXV */

      this.ZOC_INFORMATION.removeKoma( postKomaInfoBeforeRollback, entry.postX, entry.postY );
      this.ZOC_INFORMATION.putKoma( entry.preKomaInfo, entry.preX, entry.preY );
      
      if( entry.postMasuInfo != EMPTY ) {

        this.ZOC_INFORMATION.putKoma( entry.postMasuInfo, entry.postX, entry.postY );

      }// if(...)

      
      if( entry.postMasuInfo == EMPTY ) {
        
        this.ZOC_INFORMATION.extendSequenceZOC( entry.postX, entry.postY );
        
      }// if(...)
            
    
      // Kvł΁Ȁɖ߂
      if( entry.postMasuInfo != EMPTY ) {
      
        this.komadai[ this.teban ? 1 : 0 ][ KomaUtil.getArchetype( entry.postMasuInfo ) - 1 ]--;
      
      }// if(...)

    }// if(...)
    
    // ԏ
    this.teban = ! this.teban;
    
    
  }// rollback()

  
  /**
   * ̉̈ʒui؁jB
   */
  private int senteOuX;
  
  /**
   * ̉̈ʒuiijB
   */
  private int senteOuY;
  
  /**
   * ̉̈ʒui؁jB
   */
  private int goteOuX;
  
  /**
   * ̉̈ʒuiijB
   */
  private int goteOuY;
  
  
  /**
   * ̈ʒui؁j擾B
   * 
   * @param sente ̉̈ʒu擾ȂtrueAȂfalseB
   * @return ̋؁B
   * @since 1.0
   */
  public int getOuX( boolean sente ) {
     
     // {ɉ邩ǂ`FbN
     assert this.banmen[ sente?senteOuX:goteOuX ][ sente?senteOuY:goteOuY ] == ( KomaUtil.OU | ( sente?0:KomaUtil.GOTE ) ) : (teban?senteOuX:goteOuX) +","+ (teban?senteOuY:goteOuY) +"\n"+ this;
     
     return sente ? senteOuX : goteOuX;
  
  }// getOuX(boolean)

  
  
  /**
   * ̈ʒui؁j擾B
   * 
   * @param sente ̉̈ʒu擾ȂtrueAȂfalseB
   * @return ̋؁B
   * @since 1.0
   */
  public int getOuY( boolean sente ) {
     
     // {ɉ邩ǂ`FbN
     assert this.banmen[ sente?senteOuX:goteOuX ][ sente?senteOuY:goteOuY ] == ( KomaUtil.OU | ( sente?0:KomaUtil.GOTE ) );
     
     return sente ? senteOuY : goteOuY;
  
  }// getOuY(boolean)

  
  /**
   * ԂŖĂ邩ǂ`FbNB
   * 
   * @return ȂtrueAȊOȂfalseB
   * @since 1.0
   */
  public boolean isOute() {
     
     // ̈ʒu擾
     int ouX = this.getOuX( this.teban );
     int ouY = this.getOuY( this.teban );
     
     // ̈ʒuZOCȂΉB
     return this.getZOCInfo( !this.teban )[ ouX - 1 ][ ouY - 1 ] != 0;
     
  }// isOute()
  
  
  /**
   * ̋ǖʂŋlł邩ǂԂB
   * ïŉ邩ǂȂ̂ŁA3l݈ȏ͌Ȃǂ̕KvBj
   * 
   * @return lłtrueAȊOȂfalseB
   * @since 1.0
   */
  public boolean isItteTsumi() {
     
     // ̈ʒu擾
     int ouX = this.getOuX( !this.teban );
     int ouY = this.getOuY( !this.teban );
     
     // ̈ʒuZOCȂ΋lłB
     return this.getZOCInfo( this.teban )[ ouX - 1 ][ ouY - 1 ] != 0;
          
  }// isItteTsumi(boolean)
  
  

  
  

  
  
  // remove for update  checkTsumiycheckTsumiInnerTsumiCheckerɈڊ  
  
  
  /*
   *  ( Javadoc)
   * @see java.lang.Object#toString()
   */
  public String toString() {


     StringBuffer result = new StringBuffer();

     result.append( "----------------------------------------------------------------\n" );

    
    
     //  Ֆʂ̏ǉ

     result.append( "+---+---+---+---+---+---+---+---+---+\n" );
    
     for( int y = 1; y <= 9; y++ ) {

       result.append( '|' );

       for( int x = 9; 1 <= x ; x-- ) {
 
         result.append( KomaUtil.toString( this.banmen[ x ][ y ]  ) );
         result.append( '|' );

       }// for(..y..)
      
       result.append( '\n' );
       result.append( "+---+---+---+---+---+---+---+---+---+\n" );
      
     }// for(..x..) 
    
    
     // ̏ǉ
     result.append( ",,j,,,p,\n" );
    
     for( int sente = 0; sente <= 1; sente++ ) {
      
       for( int komaType = KomaUtil.HU; komaType <= KomaUtil.HISYA; komaType++ ) {
        
           result.append( ' ' );
           result.append( this.komadai[ sente ] [ komaType - 1 ] );
           result.append( ',' );

       }// for(..komaType..)
      
       result.deleteCharAt( result.length() - 1 );
       result.append( '\n' ); 
     
      
     }// for(..sente..)
    
    
     // ԏǉ
     result.append( " F " );
     result.append( this.teban ? "" : "" );
     result.append( '\n' );

     result.append( "----------------------------------------------------------------\n" );

     return result.toString();

    
  }// toString()


  public static void main(String[] args) throws Exception {
    
    Kyokumen kyokumen = new Kyokumen();
    Te te;
    
    if( true ) {
      
      // System.setOut( new PrintStream( new FileOutputStream( "random_result.txt" ) ) );
      
      Random random = new Random( 1 <= args.length ? Integer.parseInt( args[0] ) : 0 ); 

      
      int maxCount = 1000;
      while( true ) {
        
        if( false ) break;
        
        System.err.println( "loop." );
        
        for( int c = 0; c < maxCount; c++ ) {
       
          //System.out.println( c + "" );
//          if( c % 100 == 0 ) System.err.println( c + "" );
       
          List list = kyokumen.getApplicableTeList();
          //System.out.println( list );
                 
          Collections.shuffle( list, random );
          Te t = ( Te ) list.get( 0 );
          kyokumen.apply( t );
          
          
          kyokumen.getZOCInfo( true );
          kyokumen.getZOCInfo( false );
          
          // System.out.println( t );
          // System.out.println( kyokumen );
          
        }// for(..c..)

                
        for( int c = 0; c < maxCount; c++ ) {
          
          kyokumen.rollback();
          
          kyokumen.getZOCInfo( true );
          kyokumen.getZOCInfo( false );
   
        }// for(..c..)
        
        
        System.err.println( "finish." );
        Thread.sleep( 2000 );
        
      }//while( true )
      
      
      System.exit( 0 );
      
    }// if(...) _ړ

    System.out.println( "" );        
    System.out.println( kyokumen );


    te = new Te( KomaUtil.HU, 7, 7, 7, 6 );
    kyokumen.apply( te );
  
    System.out.println( "\n\n" );        
    System.out.println( kyokumen );


    te = new Te( KomaUtil.HU | KomaUtil.GOTE, 3, 3, 3, 4 );
    kyokumen.apply( te );
    
    System.out.println( "\n\n" );        
    System.out.println( kyokumen );


    te = new Te( KomaUtil.KAKU | KomaUtil.NARI , 8, 8, 2, 2 );
    kyokumen.apply( te );
    
    System.out.println( "\n\nO" );        
    System.out.println( kyokumen );


    te = new Te( KomaUtil.GIN | KomaUtil.GOTE, 3, 1, 2, 2 );
    kyokumen.apply( te );
    
    System.out.println( "\n\nl" );        
    System.out.println( kyokumen );


    // w̃Xgo
    //System.out.println( kyokumen.getApplicableTeList() );
    
    
    te = new Te( KomaUtil.KAKU, 0, 0, 5, 5 );
    kyokumen.apply( te );
    
    System.out.println( "\n\n܎" );        
    System.out.println( kyokumen );

    
    kyokumen.rollback();
    
    System.out.println( "\n\n[obNFl" );        
    System.out.println( kyokumen );

    
    kyokumen.rollback();
    
    System.out.println( "\n\n[obNFO" );        
    System.out.println( kyokumen );


    kyokumen.rollback();
    
    System.out.println( "\n\n[obNF" );        
    System.out.println( kyokumen );


    te = new Te( KomaUtil.KAKU, 8, 8, 6, 6  );
    kyokumen.apply( te );
    
    System.out.println( "\n\nOځiwj" );        
    System.out.println( kyokumen );

    
	}// main(String[])
  
}// Kyokumen

// EOF