/*
 * Copyright (C) 2004 by X S ( Morioka Yuichi ) .
 *
 * 2004/10/03쐬B
 */
package jp.co.infoseek.hp.streakeagle.lib.util;

import java.text.*;

/**
 * zɊւ郆[eBeB\bhW߂NXB
 * 
 * @author X S ( Morioka Yuichi )
 * @version 1.0 
 * @since 1.0
 */
public class ArrayUtil {
  
  
  /**
   * 2̓񎟌z̗vfyъi[ĂlrB
   * 
   * @param array1 z񂻂1B
   * @param array2 z񂻂2B
   * @return trueAȊȌꍇfalseB
   */
  public static boolean equals2D( int[][] array1, int[][] array2 ) {
    
    // ꎟڂ̒`FbN
    if( array1.length != array2.length ) {
     
      System.err.println( "Array length mismatch." );
      return false;
      
    }// if(...)
    
    
    for( int i1 = 0; i1 < array1.length; i1++ ) {
      
      // 񎟌ڂ̒`FbN
      if( array1[ i1 ].length != array2[ i1 ].length ) {
        
        System.err.println( "Array length ( of 2nd Dimension ) mismatch." );

        return false;
        
      }// if(...)
      
      
      for( int i2 = 0; i2 < array1[ i1 ].length; i2++ ) {
        
        // i[Ăl̃`FbN
        if( array1[ i1 ][ i2 ] != array2[ i1 ][ i2 ] ) {
          
          System.err.println( "Value mismatch." );
          System.err.println( "\t" + i1 +","+ i2 +"  "+ array1[ i1 ][ i2 ] +" != "+ array2[ i1 ][ i2 ] );  
          return false;
          
        }// if(...)
        
      }// for(..i2..)
      
    }// for(..i1..)
    
    
    // S`FbNpX΁A
    return true;
    
  }// equals2D(int[][],int[][])
  
  
  
  public static int[][] minus2D( int[][] array1, int[][] array2 ) {
    
    int[][] result = new int[ array1.length ][ array1[ 0 ].length ];
    
    
    for( int i1 = 0; i1 < array1.length; i1++ ) {
      
      for( int i2 = 0; i2 < array1[ i1 ].length; i2++ ) {
        

        result[ i1 ][ i2 ] = array1[ i1 ][ i2 ] - array2[ i1 ][ i2 ];

        
      }// for(..i2..)
      
    }// for(..i1..)
    
    

    return result;
    
  }// minus2D(int[][],int[][]) 

  
  private static final DecimalFormat df = new DecimalFormat( "###,###,##0" );
  
  
  public static String toString( int[] array ) {
    
    StringBuffer result = new StringBuffer();
    int total = 0;

    result.append( "[ " );
    
    for( int i = 0; i < array.length; i++ ) {

      result.append( array[ i ] + ", " );
      total += array[ i ];

    }// for(..i1..)
    
    result.append( "]   total : " );
    
    result.append( df.format( total ) );
    
    return result.toString();
    
  }// toString(int[])
  
  
  public static String toString( int[][] array ) {

    StringBuffer result = new StringBuffer();
    
    for( int i1 = 0; i1 < array.length; i1++ ) {
      
      for( int i2 = 0; i2 < array[ i1 ].length; i2++ ) {
        

        result.append( array[ i1 ][ i2 ] + "," );

        
      }// for(..i2..)
      
      result.append( "\n" );
      
    }// for(..i1..)
    
    return result.toString();
    
  }// toString(int[][])

}// ArrayUtil

// EOF